      SUBROUTINE ABCD(U,V,W,
     1   RRMAX,RTMAX,RZMAX,ERMAX,ETMAX,EZMAX,XACC,YACC,ZACC,NF,NFILE,
     2   SUM1,SUM2,SUM3,SUM4,SUM5,SUM6,SUM7,SUM8,SUM9,
     2   SUM10,SUM11,SUM12,SUM13,EVRCOR,
     3   SUMWEIGHT,TOLERANCE,KMIN2,KMAX2,
     4   SINTOL,SRB,STHETAB,SZB,RZB,THETAZB,ZZB,ROTB,
     5   IMAXB,JMAXB,KMAXB,SUMDBZ,
     6   BETATEST,SUMWTSAVE,XWSAVE,YWSAVE,ZWSAVE,UNEW,IGUESS,FACTR,
     7   ICONTINUITY,IVWIND,FACTZ,IREADABCD,OLAT,OLON,LUSCAN,
     9   IRSW,HB1,DPB1,HB2,DPB2,SLOPE1,IFFILTER,CENTIME,TSTART,TEND,
     1   SMOTIONU,SMOTIONV,FLIGHTID,RDEL,DBZTEST,RRRR,ZLOW,ZHIGH,INDEX1,
     1   UGUESS,VGUESS,WGUESS,IREVERSE,IRAMSFILES,XSHIFT,YSHIFT,IECHO,
     1   DISTXYZ,PIMAX,IJTEST,IVSPEED,VSPEED0,VFACTOR,TATF,SUMMER,
     1   IGRAPHICS,IPLANE,IVARIATIONAL,IAFTFORE,INOUT,ISIGMET,IREALTIME,
     1   ROLLTOL,NSKIP,IDBZADD,IDBZMASK,G4P3RADMIN,GROUNDADJUST,
     1   ALLOWEDDIFF,RADRAT,RADMASK,IAPPLYMASK,IUNDERONLY,
     1   JTRAKAZMMIN,JTRAKAZMMAX)
C     1   IBINS,UG,VG,WG)
      include "hrd_radar_settings.f"
      PARAMETER(MAX_X=750,MAX_Y=250)
      CHARACTER FLIGHTID*8, CHARV*2, CHARDBZ*2
      CHARACTER DISPLAY_LABEL*32,WINDOW_LABEL*28
      CHARACTER DISPLAY_LABELZ*32,WINDOW_LABELZ*18
      CHARACTER CHARTIME*6,CHARTIMEMIN*6,CHARTIMEMAX*6,CHARAFTFORE*5
      REAL AZIRAD(400)
      INTEGER RAW_WINDOW(100),RAWZ_WINDOW(100)
      INTEGER*2 DBZ_INT(MAX_X,MAX_Y)
      INTEGER WINDOWERROR
      INTEGER DATA_TYPE
      REAL GTLENGTH(MAX_HRD_DIM)
      REAL UG(8000000),VG(8000000),WG(8000000)
      REAL SUMWEIGHTP(400,200,200,2)
      DOUBLE PRECISION SUMWTSAVE(IMAXB,JMAXB,KMAXB,2)
      REAL XWSAVE(IMAXB,JMAXB,KMAXB,2)
      REAL YWSAVE(IMAXB,JMAXB,KMAXB,2),ZWSAVE(IMAXB,JMAXB,KMAXB,2)
      REAL UMEAN(400,360),VMEAN(400,360),WMEAN(400,360)
      REAL U(IMAXB,JMAXB,KMAXB),V(IMAXB,JMAXB,KMAXB)
      REAL W(IMAXB,JMAXB,KMAXB)
      DOUBLE PRECISION SUMDBZ(IMAXB,JMAXB,KMAXB,2)
      REAL VR(MAX_HRD_DIM),RANGE(MAX_HRD_DIM),DBZ(MAX_HRD_DIM)
      REAL XR(MAX_HRD_DIM),YR(MAX_HRD_DIM),ZR(MAX_HRD_DIM)
      REAL RAD(MAX_HRD_DIM),THETA(MAX_HRD_DIM)
      DOUBLE PRECISION SUM1(IMAXB,JMAXB,KMAXB,2)
      DOUBLE PRECISION SUM2(IMAXB,JMAXB,KMAXB,2)
      DOUBLE PRECISION SUM3(IMAXB,JMAXB,KMAXB,2)
      DOUBLE PRECISION SUM4(IMAXB,JMAXB,KMAXB,2)
      DOUBLE PRECISION SUM5(IMAXB,JMAXB,KMAXB,2)
      DOUBLE PRECISION SUM6(IMAXB,JMAXB,KMAXB,2)
      DOUBLE PRECISION SUM7(IMAXB,JMAXB,KMAXB,2)
      DOUBLE PRECISION SUM8(IMAXB,JMAXB,KMAXB,2)
      DOUBLE PRECISION SUM9(IMAXB,JMAXB,KMAXB,2)
      DOUBLE PRECISION SUM10(IMAXB,JMAXB,KMAXB,2)
      DOUBLE PRECISION SUM11(IMAXB,JMAXB,KMAXB,2)
      DOUBLE PRECISION SUM12(IMAXB,JMAXB,KMAXB,2)
      DOUBLE PRECISION SUM13(IMAXB,JMAXB,KMAXB,2)
      REAL UGUESS(IMAXB,JMAXB,KMAXB),VGUESS(IMAXB,JMAXB,KMAXB)
      REAL WGUESS(IMAXB,JMAXB,KMAXB),RHOK(200)
      REAL DISTXYZ(IMAXB,JMAXB,KMAXB,2,2,2,2)
      REAL VRSWP(MAX_HRD_DIM,800),REFSWP(MAX_HRD_DIM,800)
      REAL VRSWP1(MAX_HRD_DIM,800),REFSWP1(MAX_HRD_DIM,800)
      REAL VRRAD(MAX_HRD_DIM,800)
      REAL RDTAI(MAX_HRD_DIM),AZ_EL(2,800),EAZM(800),EEV(800)
      REAL VNYQ(MAX_HRD_DIM,800),PELEV(800)
      INTEGER JINDEX(MAX_HRD_DIM,800),JIINDEX(MAX_HRD_DIM,800)
      REAL TMP1(MAX_HRD_DIM,800),TMP2(MAX_HRD_DIM,800)
      REAL UNFVEL(MAX_HRD_DIM,800)
      REAL SWEEPSAVE(MAX_HRD_DIM,800)
      REAL TMSWEEP(800),RRLAT(800),RRLON(800),RRA(800)
      CHARACTER*2 TATF(80),TAF
c      INTEGER*2 CHECKVR(100,400,50),CHECKDBZ(100,400,50)
      DOUBLE PRECISION SUMMER(IMAXB,JMAXB,KMAXB,2)
      INTEGER INDEX1(IMAXB,JMAXB,KMAXB,2)
      INTEGER NS(3)
      REAL XSHIFT(80),YSHIFT(80)
      FLAG=-1.0E+10
      NCOUNT=-1
      IF(INOUT.EQ.1)THEN
       OPEN(76,FILE='aziradin')
      ELSEIF(INOUT.EQ.2)THEN
       OPEN(76,FILE='aziradout')
      ENDIF
      READ(76,*)AZIRAD
      RHIGH=200.
      IF(IGRAPHICS.EQ.1)THEN
       ILOG_LU=6
       WINDOW_LABEL='cleaned up radial velocities'
       WINDOW_LABELZ='reflectivity (dBZ)'
       CALL RASX_OPEN_WINDOW(RAW_WINDOW,WINDOWERROR,
     +  WINDOW_LABEL)
       CALL RASX_OPEN_WINDOW(RAWZ_WINDOW,WINDOWERROR,
     +  WINDOW_LABELZ)
      ENDIF
c      write(6,*)'entered abcd'
      IUSEWIND=IGUESS
      IF(IUSEWIND.EQ.1)THEN
       IJKMX=IMXG*JMXG*KMXG
       CALL READWIND(UG,VG,WG,IMXG,JMXG,KMXG,SXG,SYG,SZG,
     + OLATG,OLONG,XZG,YZG,ZZG,IJKMX,ZLOW,ZHIGH,HB2,DPB2)
      ENDIF
      ISCANMAX=300
      OPEN(93,FILE='SUMMINGS')
      MAX_GATES=MAX_HRD_DIM
      MAX_RAYS=800
      MDIM=IMAXB*JMAXB*KMAXB
      WRITE(6,*)'IMAXB,JMAXB,KMAXB = ',IMAXB,JMAXB,KMAXB
      WRITE(6,*)'MDIM = IMAXB*JMAXB*KMAXB = ',MDIM
      PI=2.*ASIN(1.)
      PI2=2.*PI
      DTR=PI/180.
      ISCANDIM=MAX_HRD_DIM
      IBINS=7
      SXB2=.5*SXB*SXB
      SYB2=.5*SYB*SYB
      SZB2=.5*SZB*SZB
      JBINS=3*IBINS+1
      DO L=1,2
       DO K=1,KMAXB
        HEIGHT=ZZB+(K-1)*SZB
        RHO=EXP(-HEIGHT*.10437052)
        RHOK(K)=RHO
        DO J=1,JMAXB
         DO I=1,IMAXB
          DO KK=1,2
           DO JJ=1,2
            DO II=1,2
             DISTXYZ(I,J,K,L,II,JJ,KK)=1000.
            ENDDO
           ENDDO
          ENDDO
         ENDDO
        ENDDO
       ENDDO
      ENDDO
      ZTOP=(KMAXB-1)*SZB+ZZB
      RLZ=ZTOP
      RLH=25.*SXB
      UBAR=10.
      DO I=1,MAX_HRD_DIM
       A=I
       RANGE(I)=A
       VR(I)=-A
       DBZ(I)=A*2.
      ENDDO
      write(6,*)'entered abcd'
      NS(1)=0
      NS(2)=0
      NS(3)=1
      NSTEP=2
      NSTEP2=1
      MDIM2=IMAXB*JMAXB
      WRITE(6,*)'IMAXB,JMAXB,KMAXB,SXB,SYB,SZB,ROTB'
      WRITE(6,*)IMAXB,JMAXB,KMAXB,SXB,SYB,SZB,ROTB
      WRITE(6,*)'Entered ABCD'
      RRWEIGHT=ERMAX*ERMAX
      RTWEIGHT=ETMAX*ETMAX
      RZWEIGHT=EZMAX*EZMAX
      WRITE(6,*)'EHMAX,EZMAX,RXMAX,RYMAX,RZMAX'
      WRITE(6,*)EHMAX,EZMAX,RXMAX,RYMAX,RZMAX    
      WRITE(6,*)'XACC = ',XACC
      WRITE(6,*)'YACC = ',YACC
      WRITE(6,*)'ZACC = ',ZACC
      TIMER=0.
c      WRITE(1,*)'AFTER ENTERING ABCD, FACTZ,FACTR = ',FACTZ,FACTR
C      IF(IGUESS.NE.1
C     + .AND.IREADABCD.NE.1)THEN
      DO L=1,2
       DO K=1,KMAXB
        DO I=1,IMAXB
         SUMV=0.
         SUMU=0.
         SUMW=0.
         DO J=1,JMAXB
          SUMV=SUMV+VGUESS(I,J,K)
          SUMU=SUMU+UGUESS(I,J,K)
          SUMW=SUMW+WGUESS(I,J,K)
         ENDDO
         VMEAN(I,K)=SUMV/JMAXB
         UMEAN(I,K)=SUMU/JMAXB
         WMEAN(I,K)=SUMW/JMAXB
        ENDDO
       ENDDO
       IF(IREADABCD.NE.1)THEN
        DO KK=KMIN2,KMAX2
         DO JJ=1,JMAXB
          DO II=1,IMAXB
C
C First call to ABCD:  zero all angle-projection summations
C
           SUMWEIGHTP(II,JJ,KK,L)=0
           SUMDBZ(II,JJ,KK,L)=0
           SUMWTSAVE(II,JJ,KK,L)=0
           SUM1(II,JJ,KK,L)=0
           SUM2(II,JJ,KK,L)=0
           SUM3(II,JJ,KK,L)=0
           SUM4(II,JJ,KK,L)=0
           SUM5(II,JJ,KK,L)=0
           SUM6(II,JJ,KK,L)=0
           SUM7(II,JJ,KK,L)=0
           SUM8(II,JJ,KK,L)=0
           SUM9(II,JJ,KK,L)=0
           SUM10(II,JJ,KK,L)=0
           SUM11(II,JJ,KK,L)=0
           SUM12(II,JJ,KK,L)=0
           SUM13(II,JJ,KK,L)=0
           XWSAVE(II,JJ,KK,L)=0
           YWSAVE(II,JJ,KK,L)=0
           ZWSAVE(II,JJ,KK,L)=0
           INDEX1(II,JJ,KK,L)=0
           SUMMER(II,JJ,KK,L)=0
c           CHECKVR(II,JJ,KK,L)=0
c           CHECKDBZ(II,JJ,KK,L)=0
C
C If w found during first iteration, set to zero to begin second iteration
C
          ENDDO
         ENDDO
        ENDDO
       ENDIF
      ENDDO
c5556  OPEN(103,FILE='/hrd/dat/gustav/tracking/insideabcd')
c      WRITE(103,*)'AT STATEMENT 5556--NF=',NF
c      CLOSE(103)
      IBEGIN=0
      TIMES=0.
      NRECORD=1
      RLATBEFORE=0.
      ICLSWP=0
      IF(IREADABCD.EQ.1)GO TO 72735
c92923 CALL SCANNER(TIMES,RLAT,RLON,ELEV,AZIM,DBZ,VR,RANGE,RALT)
c92923 READ(LUSCAN)TIMES,RLAT,RLON,ELEV,AZIM,DBZ,VR,RANGE,RALT
c      write(6,*)'calling readuf_disc'
92923 TAF=TATF(1)
      DO I=1,MAX_HRD_DIM
       VR(I)=FLAG
       DBZ(I)=FLAG
      ENDDO
c      write(6,*)'calling iclswp = ',iclswp
c      write(6,*)'calling sweepin iusewind = ',iusewind
c      WRITE(6,*)'ABCD IAFTORE = ',IAFTFORE
      NCOUNT=NCOUNT+1
      NDO=NCOUNT-NSKIP*(NCOUNT/NSKIP)
      WRITE(6,*)'NCOUNT,NSKIP,NDO = ',NCOUNT,NSKIP,NDO
c      PAUSE
      CALL SWEEPIN(VRSWP,REFSWP,MAX_RAYS,MAX_GATES,NUM_RAYS,RDTAI,
     + AZ_EL,ICLSWP,NRECORD,VRRAD,UNFVEL,TMP1,TMP2,JINDEX,
     + JIINDEX,VNYQ,ILATERSWEEP,SWEEPSAVE,UG,VG,WG,
     + IMXG,JMXG,KMXG,SXG,SYG,SZG,OLATG,OLONG,XZG,YZG,ZZG,
     + IUSEWIND,EAZM,EEV,TMSWEEP,RRLAT,RRLON,RRA,
     + SMOTIONU,SMOTIONV,CENTIME,PELEV,IPLANE,IVARIATIONAL,IAFTFORE,
     + INOUT,ISIGMET,IREALTIME,ROLLTOL,NDO,IDBZADD,IDBZMASK,
     + G4P3RADMIN,GROUNDADJUST,ALLOWEDDIFF,RADRAT,RADMASK,IAPPLYMASK,
     + IUNDERONLY,JTRAKAZMMIN,JTRAKAZMMAX)
       NBINMAX=1
       IF(NDO.NE.0)GO TO 92923
      ICLSWP=1
      IF(NUM_RAYS.LE.0.AND.TIMES.LT.TEND)GO TO 92923
      NR=1
      TMSWEEPMIN=300000.
      TMSWEEPMAX=0.
      PELEVSUM=0
      DO J=1,NUM_RAYS
       PELEVSUM=PELEVSUM+PELEV(J)
       IF(TMSWEEP(J).GT.TMSWEEPMAX)TMSWEEPMAX=TMSWEEP(J)
       IF(TMSWEEP(J).LT.TMSWEEPMIN)TMSWEEPMIN=TMSWEEP(J)
       TIMES=TMSWEEP(J)
      ENDDO
      PELEVSUM=PELEVSUM/NUM_RAYS
      DO I=1,MAX_HRD_DIM
       RANGE(I)=RDTAI(I)
       GTLENGTH(I)=RDTAI(I)
       IF(RANGE(I).GT.0..AND.RANGE(I).LT.200.)THEN
        IF(I.GT.NBINMAX)NBINMAX=I
       ENDIF
      ENDDO
      WRITE(6,*)'NBINMAX = ',NBINMAX
      DO I=1,MAX_HRD_DIM
       IF(RANGE(I).GT.RHIGH)RANGE(I)=RHIGH+.01
      ENDDO
      ISCANMAX=NBINMAX
      IF(IGRAPHICS.EQ.1)THEN
       RMX=GTLENGTH(ISCANMAX)
       XDIS=37.5
       YDIS=15.0
       IF(IPLANE.EQ.1)YDIS=7.
       SWEEPSX=.10
       SWEEPSY=.10
       IMAXSWEEP=MAX_X
       JMAXSWEEP=MAX_Y
       MAXX=MAX_X
       MAXY=MAX_Y
       RDEL=0.
       RDEL_Z=0.
       NMOSM=0
       BAD_VAL=-888.8
       DOPMIN=-90.
       DOPMAX=90.
       TOO_NOISY=-200.
       AMBIGUOUS=-100.
       BAD_VALZ=-32.0
       DBZMIN=-20.
       DBZMAX=55.
       DATA_TYPE=2
       IXL=20
       IYB=20
c       write(6,*)'rmx = ',rmx
C
C END VARIABLES FOR SCAN GRAPHICS
C
       DO J1=1,NUM_RAYS
c        WRITE(6,*)J1,EEV(J1)
c        WRITE(6,'(10F8.2)')(REFSWP(I1,J1),I1=1,500)
        DO I1=1,MAX_HRD_DIM
         VRSWP1(I1,J1)=VRSWP(I1,J1)
         REFSWP1(I1,J1)=REFSWP(I1,J1)
         IRANGER=INT((RANGE(I1)+.001)/5.)
         REMRANGER=RANGE(I1)-IRANGER*5.
         IF(REMRANGER.LT..21)THEN
          VRSWP1(I1,J1)=DOPMAX-1.
          REFSWP1(I1,J1)=DBZMAX-1.
         ENDIF
        ENDDO
c        WRITE(6,*)'J1 = ',J1
c        WRITE(6,8642)(VRSWP(I,J1),I=1,NBINMAX)
c        WRITE(6,*)'J1 = ',J1
c        WRITE(6,8642)(VRSWP1(I,J1),I=1,NBINMAX)
8642   FORMAT(10F8.1)
       ENDDO
       IHOURSMIN=TMSWEEPMIN/3600.
       SECLEFT=TMSWEEPMIN-IHOURSMIN*3600.
       IMINSMIN=SECLEFT/60.
       ISECSMIN=TMSWEEPMIN-IHOURSMIN*3600.-IMINSMIN*60.
       ITHHMMSS=IHOURSMIN*10000+IMINSMIN*100+ISECSMIN
       WRITE(CHARTIMEMIN,'(3I2.2)')IHOURSMIN,IMINSMIN,ISECSMIN
c       WRITE(6,'(3I2.2)')IHOURSMIN,IMINSMIN,ISECSMIN
       IHOURSMAX=TMSWEEPMAX/3600.
       SECLEFT=TMSWEEPMAX-IHOURSMAX*3600.
       IMINSMAX=SECLEFT/60.
       ISECSMAX=TMSWEEPMAX-IHOURSMAX*3600.-IMINSMAX*60.
       ITHHMMSS=IHOURSMAX*10000+IMINSMAX*100+ISECSMAX
       WRITE(CHARTIMEMAX,'(3I2.2)')IHOURSMAX,IMINSMAX,ISECSMAX       
c       WRITE(6,'(3I2.2)')IHOURSMAX,IMINSMAX,ISECSMAX       
       IF(PELEVSUM.GT.0.)THEN
        WRITE(CHARAFTFORE,'(A5)')' FORE'
       ELSE
        WRITE(CHARAFTFORE,'(A5)')' AFT '
       ENDIF
c       write(6,*)'calling solo_convt'
C       ISCANMAX=NBINMAX
       NBINMAX=ISCANMAX
       IF(ISCANMAX.GT.960)ISCANMAX=960
c       WRITE(6,*)'DATA_TYPE = ',DATA_TYPE
c       WRITE(6,*)'ELMIN,ELMAX = ',ELMIN,ELMAX
c       WRITE(6,*)'MAXX,MAXY,ILOG,LU = ',MAXX,MAXY,ILOG,LU
c       WRITE(6,*)'MAX_GATES,ISCANMAX,NUM_RAYS,IERSM = ',
c     1            MAX_GATES,ISCANMAX,NUM_RAYS,IERSM
c       WRITE(6,*)'IMAXSWEEP,JMAXSWEEP,SWEEPSX,SWEEPSY,RMX,RDEL_Z = ',
c     1            IMAXSWEEP,JMAXSWEEP,SWEEPSX,SWEEPSY,RMX,RDEL_Z
c       WRITE(6,*)'TIMES,NMOSM,ITFLG,BAD_VAL = ',
c     1            TIMES,NMOSM,ITFLG,BAD_VAL
c       WRITE(6,*)'GTLENGTH = ',(GTLENGTH(I),I=1,ISCANMAX)
c       DO J=1,NUM_RAYS
c        WRITE(6,*)'VRSWP1 J = ',J
c        WRITE(6,'(10F8.2)')(VRSWP1(I,J),I=1,ISCANMAX)
c       ENDDO
       CALL SOLO_CONVT(DATA_TYPE,ELMIN,ELMAX,
     +  DBZ_INT,MAXX,MAXY,ILOG_LU,
     +  AZ_EL,VRSWP1,MAX_GATES,NBINMAX,NUM_RAYS,IERSM,
C     +  AZ_EL,VRSWP,MAX_GATES,ISCANMAX,NUM_RAYS,IERSM,
     +  IMAXSWEEP,JMAXSWEEP,SWEEPSX,SWEEPSY,XDIS,YDIS,RLATDUM,
     +  RLONDUM,SLATDUM,SLONDUM,RMX,RDEL_Z,TIMES,NMOSM,ITFLG,
     +  GTLENGTH,BAD_VAL)
c       DO J=1,MAXY
c        WRITE(6,*)'DBZ_INT J = ',J
c        WRITE(6,'(20I4)')(DBZ_INT(I,J),I=1,MAXX)
c       ENDDO
c       write(6,*)'returned from solo_convt calling show_iz'
       CALL SHOW_IZ(IXL,IYB,DBZ_INT,MAXX,MAXY,IMAXSWEEP,JMAXSWEEP,
     +  DOPMIN,DOPMAX,DATA_TYPE,TOO_NOISY,AMBIGUOUS,
     +  RAW_WINDOW,DISPLAY_LABEL,CHARTIMEMIN,CHARTIMEMAX,CHARAFTFORE)
       DATA_TYPE=1
c       write(6,*)'returned from show_iz calling solo_convt'
       CALL SOLO_CONVT(DATA_TYPE,ELMIN,ELMAX,
     +  DBZ_INT,MAXX,MAXY,ILOG_LU,
     +  AZ_EL,REFSWP1,MAX_GATES,ISCANMAX,NUM_RAYS,IERSM,
c     +  AZ_EL,REFSWP1,MAX_GATES,NBINMAX,NUM_RAYS,IERSM,
     +  IMAXSWEEP,JMAXSWEEP,SWEEPSX,SWEEPSY,XDIS,YDIS,RLATDUM,
     +  RLONDUM,SLATDUM,SLONDUM,RMX,RDEL_Z,TIMES,NMOSM,ITFLG,
     +  GTLENGTH,BAD_VALZ)
c       write(6,*)'returned from solo_convt calling show_iz'
       CALL SHOW_IZ(IXL,IYB,DBZ_INT,MAXX,MAXY,IMAXSWEEP,JMAXSWEEP,
     +  DBZMIN,DBZMAX,DATA_TYPE,TOO_NOISY,AMBIGUOUS,
     +  RAWZ_WINDOW,DISPLAY_LABELZ,CHARTIMEMIN,CHARTIMEMAX,CHARAFTFORE)
c       write(6,*)'returned from show_iz done for this sweep'
      ENDIF
92924 DO WHILE(NR.LE.NUM_RAYS)
       ELEVTEST=PELEV(NR)
c       WRITE(6,*)'TMSWEEP,NR,ELEVTEST = ',TMSWEEP(NR),NR,ELEVTEST
       TAF=TATF(1)
c       WRITE(6,'(A2)')TAF
       IF(ELEVTEST.LE.0.OR.'TAF'.EQ.'TN')THEN
c        IF(ELEVTEST.LE.0.)WRITE(6,*)'GOING TO 27272'
C        IF(ELEVTEST.LE.0.)GO TO 27272
        L2=1
        NF=1
       ELSE
c        IF(ELEVTEST.GT.0.)WRITE(6,*)'GOING TO 27272'
C        IF(ELEVTEST.GT.0.)GO TO 27272
        L2=2
        NF=2
       ENDIF
       RLATBEFORE=RLAT
       TIMES=TMSWEEP(NR)
       AZIM=EAZM(NR)
C
C Sweepin uses math angles but VRLOCATE was based upon using the
C UF file reader which reports back in navigational coordinates
C Thus do a reflection and check
C
       AZIM=90-AZIM
       IF(AZIM.LT.0.)AZIM=AZIM+360.  
       IF(AZIM.GT.360.)AZIM=AZIM-360.
       RALT=RRA(NR)   
       ELEV=EEV(NR)
       RLAT=RRLAT(NR)
       RLON=RRLON(NR)
       RLATR=RLAT
       RLONR=RLON
       IHOURS=TIMES/3600.
       SECLEFT=TIMES-IHOURS*3600.
       IMINS=SECLEFT/60.
       ISECS=TIMES-IHOURS*3600.-IMINS*60.
       ITHHMMSS=IHOURS*10000+IMINS*100+ISECS
c        WRITE(6,*)ITHHMMSS,RLAT,RLON,ELEV,AZIM,JJJSTART,RANGE(JJJSTART)
       DO I=1,MAX_HRD_DIM
        VR(I)=VRSWP(I,NR)
        DBZ(I)=REFSWP(I,NR)
       ENDDO
c       WRITE(6,*)'ELEV = ',ELEV
c       WRITE(6,'(6F12.4)')(RANGE(I),DBZ(I),VR(I),I=1,MAX_HRD_DIM)
c       DO I=1,128
c        if(vr(i).gt.-800..and.i.le.128.and.
c     +    (nr.eq.130.or.nr.eq.131))then
C         write(6,'(I5,3F10.3)')NR,(I,VR(I),DBZ(I),RANGE(I),LL=I,MAX_HRD_DIM)
c         write(6,*)'NR,max_gates,max_rays = ',nr,max_gates,max_rays
c         write(6,'(I4,3E11.3,I4,3E11.3)')
c     +            (LL,VR(LL),DBZ(LL),RANGE(LL),LL=I,128)
c         write(6,'(I4,3E11.3,I4,3E11.3)')
c     +            (LL,VRSWP(LL,NR),REFSWP(LL,NR),RANGE(LL),LL=I,128)
c         GO TO 4017
c        ENDIF
c       ENDDO
4017   IF(IRAMSFILES.EQ.1)THEN
        CALL READRAMFILE(TIMES,TIME_RAM,RLAT,RLON,DM1,DM2,DM3,
     *                      DM4,DM5,DM6,DM7,IOS)
        IF(IERR.EQ.0.AND.IOS.EQ.0)THEN
         RLATDIFF=RLAT-RLATR
         RLONDIFF=RLON-RLONR
c        WRITE(6,*)'RLAT,RLATR,RLATDIFF,RLON,RLONR,RLONDIFF = ',
c     +              RLAT,RLATR,RLATDIFF,RLON,RLONR,RLONDIFF
        ELSEIF(IOS.NE.0)THEN
         RLAT=RLATR+RLATDIFF
         RLON=RLONR+RLONDIFF
c        WRITE(6,*)'IOS,RLAT,RLATR,RLATDIFF,RLON,RLONR,RLONDIFF = ',
c     +              IOS,RLAT,RLATR,RLATDIFF,RLON,RLONR,RLONDIFF
        ELSE
         IHOURS=TIMES/3600.
         SECLEFT=TIMES-IHOURS*3600.
         IMINS=SECLEFT/60.
         ISECS=TIMES-IHOURS*3600.-IMINS*60.
         IHHMMSS=IHOURS*10000+IMINS*100+ISECS
         WRITE(6,*)'TIME,IOS,IERR = ',IHHMMSS,IOS,IERR
         IF(IERR.EQ.-2.OR.IERR.EQ.-3)THEN
          WRITE(6,*)'Are you giving rams coordinates to the '
          WRITE(6,*)'NEXRAD radar i.e. moving the radar?'
         ENDIF
         IF(IERR.LE.-4)GO TO 92923
        ENDIF
       ENDIF
       IF(IBEGIN.EQ.1.AND.TIMES.LT.TSTART)TIMES=TIMES+86400.
c       write(6,*)'times,tend = ',times,tend
       IF(TIMES.GT.TEND.OR.IERR.EQ.-1)GO TO 92929
       IF(TIMES.GT.TIMEOLD)THEN
c        WRITE(6,*)TIMES,RALT,RLAT,RLATR,RLON,RLONR
C        write(6,*)'range = ',(range(i),i=1,MAX_HRD_DIM)
C        write(6,*)'dbz = ',(dbz(i),i=1,MAX_HRD_DIM)
C        write(6,*)'vr = ',(vr(i),i=1,MAX_HRD_DIM)
        ITIMES=NINT(TIMES)
        ITIMEHH=ITIMES/3600
        IREMAIN=ITIMES-3600*ITIMEHH
        ITIMEMM=IREMAIN/60
        ITIMESS=IREMAIN-ITIMEMM*60
c        WRITE(6,10103)ITIMEHH,ITIMEMM,ITIMESS
c10103    FORMAT('TIME = ',3I2)
       ENDIF
        TIMEOLD=TIMES
       IF(IREADABCD.NE.1.AND.TIMES.GE.TSTART.AND.TIMES.LE.TEND)THEN
        IF(RDEL.GT.0.)THEN
         JJJSTART=1
        ELSE
         JJJSTART=2-(RDEL/.15)
         ENDIF
c       write(6,9656)(vr(i),i=11,20)
c9656   format('vr(11)-vr(20) = ',10f8.3)
c       write(6,9657)(dbz(i),i=11,20)
c9657   format('dbz(11)-dbz(20) = ',10f8.3)
        IF(RDEL.LT.0)THEN
         DO JJJ=JJJSTART,ISCANDIM
          RANGE(JJJ)=RANGE(JJJ)+RDEL
          IF(IREVERSE.EQ.1)THEN
           VR(JJJ)=-VR(JJJ)
          ENDIF
         ENDDO
        ENDIF
        RHIGH=200.
        RLOW=.1
        IHOURS=TIMES/3600.
        SECLEFT=TIMES-IHOURS*3600.
        IMINS=SECLEFT/60.
        ISECS=TIMES-IHOURS*3600.-IMINS*60.
        ITHHMMSS=IHOURS*10000+IMINS*100+ISECS
c       WRITE(6,*)ITHHMMSS,RLAT,RLON,ELEV,AZIM,JJJSTART,RANGE(JJJSTART)
c        RLOW=(RALT/1000.)+2.5
c      WRITE(6,*)TIMES,RLAT,RLON,ELEV,AZIM,JJJSTART,RANGE(JJJSTART),
c     +RLOW,RHIGH
C
C Angle projection summing follows.  
C
        IBEGIN=1
        XWEIGHT=0
        YWEIGHT=0
        ZWEIGHT=0
        SUMWEIGHT=0
        XSHFT=XSHIFT(NF)
        YSHFT=YSHIFT(NF)
c       WRITE(6,*)'OLAT,OLON,TIMES = ',OLAT,OLON,TIMES
c       WRITE(6,*)'RLAT,RLON,RALT,ELEV = ',RLAT,RLON,RALT,ELEV
c       WRITE(6,*)'RANGE(10),SMOTIONU,SMOTIONV,CENTIME = ',
c     +        RANGE(10),SMOTIONU,SMOTIONV,CENTIME
c        WRITE(6,*)'XSHFT,YSHFT = ',XSHFT,YSHFT
        CALL VRLOCATE(OLAT,OLON,TIMES,
     + RLAT,RLON,RALT,ELEV,AZIM,RANGE,XR,YR,ZR,
     + SMOTIONU,SMOTIONV,ISCANDIM,CENTIME,XSHFT,YSHFT,RAD,THETA,
     + ISCANMAX)
C       WRITE(6,*)'TIMES,ELEV,XR(1),YR(1),ZR(1) = ',
C     +  TIMES,ELEV,XR(1),YR(1),ZR(1)
        AZIMM=AZIM-ROTB
        GAMMA=SIN(ELEV*DTR)
        ALPHA=SIN(AZIMM*DTR)*COS(ELEV*DTR)
        BETA=COS(AZIMM*DTR)*COS(ELEV*DTR)
        DO I=JJJSTART,ISCANMAX
c         write(6,*)'i,range = ',i,range(i)
         DBZCHK=DBZTEST+20.*ALOG10(RANGE(I)/RRRR)
c         write(6,*)'dbzchk = ',dbzchk
         ZRCHECK=RANGE(I)/57.*.95*COS(ELEV*DTR)
         VRVR=VR(I)
cccc         IF((VR(I).GT.-800..OR.DBZ(I).GT.-30.).AND.
c     +     ZR(I).GT.ZRCHECK.AND.ZR(I).GT..075.
c     +     AND.RANGE(I).GT.RLOW.AND.RANGE(I).LT.RHIGH)THEN
cccc     +     RANGE(I).GT.RLOW.AND.RANGE(I).LT.RHIGH)THEN
C          write(6,*)'i got to 4 and i = ',i
c          write(6,*)'i,dbz,vr,rho = ',i,dbz(i),vrvr,rho
          RHO=EXP(-ZR(I)*.10437052)
          IF(ABS(GAMMA).GE.SINTOL)THEN
C
C Determine actual distance from location of datum in data file
C to the point being evaluated in output file 
C
C
C Determine actual distance from location of datum in data file
C to the point being evaluated in output file 
C
           IMIDDLE=NINT((RAD(I)-RZB)/SRB+1.)
           IF(IMIDDLE.LE.0)THEN
            IMIDDLE=1
           ELSEIF(IMIDDLE.GT.IMAXB)THEN
            IMIDDLE=IMAXB
           ENDIF
           JMIDDLE=NINT((THETA(I)-THETAZB)/STHETAB+1.)
           KMIDDLE=NINT((ZR(I)-ZZB)/SZB+1.)
c           WRITE(6,*)'I,VR(I),IMIDDLE,JMIDDLE,KMIDDLE = ',
c     +      I,VR(I),IMIDDLE,JMIDDLE,KMIDDLE
           TIMEDIFF=TIMES-CENTIME
           IF(IMIDDLE.GT.IMAXB)THEN
            IMID=IMAXB
           ELSEIF(IMIDDLE.LE.0)THEN
            IMID=1
           ELSE
            IMID=IMIDDLE
           ENDIF
           IF(KMIDDLE.GT.KMAX2)THEN
            KMID=KMAX2
           ELSEIF(KMIDDLE.LE.0)THEN
            KMID=1
           ELSE
            KMID=KMIDDLE
           ENDIF
           IF(JMIDDLE.GT.JMAXB)THEN
            JMID=JMAXB
           ELSEIF(JMIDDLE.LE.0)THEN
            JMID=1
           ELSE
            JMID=JMIDDLE
           ENDIF
           HKMID=ZZB+(KMID-1)*SZB
           RHO=EXP(-HKMID*.10437052)
           IF(VGUESS(IMID,JMID,KMID).GT.FLAG)THEN
            VSPEED=VGUESS(IMID,JMID,KMID)/RHO
           ELSE
            VSPEED=FLAG
            DO IL=IMID-1,1,-1
             IF(VGUESS(IL,JMID,KMID).GT.FLAG)THEN
              VSPEED=VGUESS(IL,JMID,KMID)/RHO
              GO TO 9984
             ENDIF
            ENDDO
9984         IF(VSPEED.EQ.FLAG)THEN
             VSPEED=60.
            ENDIF
           ENDIF
           RSPEED=0.
           WSPEED=0.
           UM=0.
           VM=0.
           WM=0.
           VSPEED=0.
c           IF(IGUESS.NE.1)VSPEED=0.
c           IF(IVSPEED.EQ.1)VSPEED=VSPEED0
           DELTHETA=-TIMEDIFF*VSPEED/RAD(I)/1000.*180./3.14159*VFACTOR
c          write(6,*)'vspeed,vfactor,deltheta = ',
c     1               vspeed,vfactor,deltheta
c          write(6,*)'iguess,ivspeed = ',iguess,ivspeed
           DELRAD=-TIMEDIFF*RSPEED/1000.
           DELH=-TIMEDIFF*WSPEED/1000.
           THETA(I)=THETA(I)+DELTHETA
           RAD(I)=RAD(I)+DELRAD
           ZR(I)=ZR(I)+DELH
           IF(THETA(I).GT.360.)THETA(I)=THETA(I)-360.
           IF(THETA(I).LT.0.)THETA(I)=THETA(I)+360.
           thetaneww=theta(i)
           JMIDDLE=NINT((THETA(I)-THETAZB)/STHETAB+1.)
           IMIDDLE=NINT((RAD(I)-RZB)/SRB+1.)
           IF(IMIDDLE.LE.0)THEN
            IMIDDLE=1
           ELSEIF(IMIDDLE.GT.IMAXB)THEN
            IMIDDLE=IMAXB
           ENDIF
           KMIDDLE=NINT((ZR(I)-ZZB)/SZB+1.)
           IDELTA=INT(RRMAX/SRB)+1
c           write(6,*)'rad(i),sthetab = ',rad(i),sthetab
           JDELTA=INT(RTMAX/STHETAB)+1
C           JDELTA=INT(RTMAX/(RAD(I)*3.14159/180.)/STHETAB)+1
c           write(6,*)'jdelta = ',jdelta
c           write(6,*)'szb = ',szb
c           write(6,*)'rzmax = ',rzmax
           KDELTA=INT(RZMAX/SZB)+1
c           write(6,*)'kdelta = ',kdelta
           IXMIN=IMIDDLE-IDELTA
           IXMAX=IMIDDLE+IDELTA
           IYMIN=JMIDDLE-JDELTA
           IYMAX=JMIDDLE+JDELTA
           IZMIN=KMIDDLE-KDELTA
           IZMAX=KMIDDLE+KDELTA
           IF(IXMIN.LT.1)THEN
            IXMIN=1
           ELSEIF(IXMIN.GT.IMAXB)THEN
            IXMIN=999
           ENDIF
           IF(IXMAX.GT.IMAXB)THEN
            IXMAX=IMAXB
           ELSEIF(IXMAX.LT.1)THEN
            IXMAX=999
           ENDIF
           IF(IZMIN.LT.KMIN2)THEN
            IZMIN=KMIN2
           ELSEIF(IZMIN.GT.KMAX2)THEN
            IZMIN=999
           ENDIF
           IF(IZMAX.LT.KMIN2)THEN
            IZMAX=999
           ELSEIF(IZMAX.GT.KMAX2)THEN
            IZMAX=KMAX2
           ENDIF
           if(rad(i).lt.-100.)then
c           if(zr(i).gt.9.9.and.zr(i).lt.10.1)then
           write(6,*)'i,rad,theta,zr = ',i,rad(i),theta(i),zr(i)
            write(6,*)'i,rzb,srb,imiddle,idelta,ixmin,ixmax = ',
     +               i,rzb,srb,imiddle,idelta,ixmin,ixmax
          write(6,*)'i,thetazb,sthetab,jmiddle,jdelta,iymin,iymax = ',      
     +               i,thetazb,sthetab,jmiddle,jdelta,iymin,iymax
            write(6,*)'i,zzb,szb,kmiddle,kdelta,izmin,izmax = ',
     +               i,zzb,szb,kmiddle,kdelta,izmin,izmax
           endif
           IF(IXMIN.LT.999.AND.IXMAX.LT.999.AND.IYMIN.LT.999.AND.
     +       IYMAX.LT.999.AND.IZMIN.LT.999.AND.IZMAX.LT.999)THEN
            ALPHAI=(ALPHA*XR(I)+BETA*YR(I))/RAD(I)
            BETAI=(-ALPHA*YR(I)+BETA*XR(I))/RAD(I)
c            write(6,*)'alphai,betai = ',alphai,betai
C           VRVR=VR(I)+45.*BETAI
c          if(vspeed.gt.60.1.or.vspeed.lt.59.9)then
c          if(vguess(imid,jmid,kmid).gt.flag)then
c          write(6,*)'i,timediff,vspeed,deltheta,delrad,delh,theta = ',  
c     1       i,timediff,vspeed,deltheta,delrad,delh,theta(i)
c          write(6,*)'i,vguess,rho = ',i,vguess(il,jmid,kmid),rho
c          write(6,*)'newtheta = ',thetaneww
c          write(6,*)'il,imid,jmid,kmid = ',il,imid,jmid,kmid
c          write(6,*)'theta,rad = ',theta(i),rad(i)
c          endif
            DO KK=IZMIN,IZMAX
             RHOVRVR=VRVR*RHOK(KK)
             HKK=ZZB+(KK-1)*SZB
             RHO=EXP(-HKK*.10437052)
             ZAN=(KK-1)*SZB+ZZB
             RZ=ZR(I)-ZAN
C
C Enclosed was just moved
c
             DO II=IXMIN,IXMAX
              RAN=(II-1)*SRB+RZB
              RX=RAD(I)-RAN
c             RTFACT=(3.14159/180.*RAD(I))**2.
              RTFACT=1.
              DO JJTEST=IYMIN,IYMAX  
C               TAN=(JJTEST-1)*STHETAB+THETAZB
               TAN=AZIRAD(IMIDDLE)
               TDIFF=THETA(I)-TAN
               IF(TDIFF.GT.180.)TDIFF=TDIFF-360.
               IF(TDIFF.LT.-180.)TDIFF=TDIFF+360.
               RYDIST=TDIFF*3.14159/180.*RAD(I)
c               RY=TDIFF
               RY=RYDIST
c      IF(ZR(I).GT.9.9.AND.ZR(I).LT.10.1)THEN
c         WRITE(6,*)'II,JJ,KK,DBZ(I),TDIFF,RHOVRVR = ',
c     +              II,JJ,KK,DBZ(I),TDIFF,RHOVRVR
c         WRITE(6,*)'II,JJ,KK,RX,RY,RZ = ',
c     +              II,JJ,KK,RX,RY,RZ
c               ENDIF
               IF(JJTEST.LT.1)THEN
                IF(IJTEST.EQ.1)THEN
                 JJ=JJTEST+JMAXB
                ELSEIF(ABS(RY).LT.RTMAX)THEN
                 JJ=JJTEST+NINT(360./STHETAB)
                ELSE
                 JJ=-1
                ENDIF
               ELSEIF(JJTEST.GT.JMAXB)THEN
                IF(IJTEST.EQ.1)THEN
                 JJ=JJTEST-JMAXB
                ELSEIF(ABS(RY).LT.RTMAX)THEN
                 JJ=JJTEST-NINT(360./STHETAB)
                ELSE
                 JJ=-1
                ENDIF
               ELSE
                JJ=JJTEST
               ENDIF
               IF(JJ.LT.1.OR.JJ.GT.JMAXB)GO TO 6298
               IF(ABS(RX).GT.RRMAX.OR.ABS(RY).GT.RTMAX.OR.
     +           ABS(RZ).GT.RZMAX)GO TO 6298
               IF(RX.LE.0)IA=1
               IF(RX.GT.0)IA=2
               IF(RY.LE.0)JA=1
               IF(RY.GT.0)JA=2
               IF(RZ.LE.0)KA=1
               IF(RZ.GT.0)KA=2
               RR=SQRT(RX*RX+RTFACT*RYDIST*RYDIST+RZ*RZ)
               IF(RR.LT.DISTXYZ(II,JJ,KK,L2,IA,JA,KA))THEN
                IF(VR(I).GT.-800.)THEN
                 DISTXYZ(II,JJ,KK,L2,IA,JA,KA)=RR
                ENDIF
               ENDIF
               ABC=RX*RX/RRWEIGHT+RY*RY/RTWEIGHT+RZ*RZ/RZWEIGHT
c               WEIGHT=EXP(-ABC)
               WEIGHT=1.0
               P=WEIGHT
C
C Accumulate weighted sums of x, y, and z distances of input data
C
               SUMWEIGHT=P
               IF(DBZ(I).GT.-100)THEN
                DBZZ=DBZ(I)*SLOPE1
                ELSE
                DBZZ=-200.
               ENDIF
C
C Perform DBZ weighted sum
C
               SUMWEIGHTP(II,JJ,KK,L2)=SUMWEIGHTP(II,JJ,KK,L2)+P
               IF(DBZ(I).GT.-30.)THEN
c                ZE=10.**(DBZZ/10.)
                ZE=DBZ(I)
C       if(dbz(i).gt.40.)then
c      write(6,*)'i,dbz(i),dbzz,slope1,ze = ',i,dbz(i),dbzz,slope1,ze
c      write(6,*)'ii,jj,kk = ',ii,jj,kk
c      write(6,*)'rad,weight,abc,rx,ry,rz = ',rad(i),weight,abc,rx,ry,rz
c      write(6,*)'before p,sumdbz,summer = ',
c     +           p,sumdbz(ii,jj,kk),summer(ii,jj,kk)
c      endif
c                IF(SUMMER(II,JJ,KK,L2).GT.0.)THEN
c                   IF(ZE.GT.SUMDBZ(II,JJ,KK,L2))THEN
c                      SUMDBZ(II,JJ,KK,L2)=ZE
c                   ENDIF
c                ELSE
c                   SUMDBZ(II,JJ,KK,L2)=ZE
c                   SUMMER(II,JJ,KK,L2)=1.
c                ENDIF
                SUMDBZ(II,JJ,KK,L2)=
     +          SUMDBZ(II,JJ,KK,L2)+P*ZE
                SUMMER(II,JJ,KK,L2)=SUMMER(II,JJ,KK,L2)+P
               ENDIF
C
C Perform weighted sums of 9 direction cosine/Vr terms
C
               IF(VR(I).GT.-800.)THEN
                SUM1(II,JJ,KK,L2)=
     +          SUM1(II,JJ,KK,L2)+P*ALPHAI*BETAI
                SUM2(II,JJ,KK,L2)=
     +          SUM2(II,JJ,KK,L2)+P*BETAI*RHOVRVR
                SUM3(II,JJ,KK,L2)=
     +          SUM3(II,JJ,KK,L2)+P*BETAI*BETAI
                SUM4(II,JJ,KK,L2)=
     +          SUM4(II,JJ,KK,L2)+P*ALPHAI*RHOVRVR
                SUM5(II,JJ,KK,L2)=
     +          SUM5(II,JJ,KK,L2)+P*ALPHAI*ALPHAI
                SUM6(II,JJ,KK,L2)=
     +          SUM6(II,JJ,KK,L2)+P*ALPHAI*GAMMA
                SUM7(II,JJ,KK,L2)=
     +          SUM7(II,JJ,KK,L2)+P*BETAI*GAMMA
                SUM8(II,JJ,KK,L2)=
     +          SUM8(II,JJ,KK,L2)+P*GAMMA*GAMMA
                SUM9(II,JJ,KK,L2)=
     +          SUM9(II,JJ,KK,L2)+P*GAMMA*RHOVRVR
                SUM10(II,JJ,KK,L2)=
     +          SUM10(II,JJ,KK,L2)+P*ALPHAI
                SUM11(II,JJ,KK,L2)=
     +          SUM11(II,JJ,KK,L2)+P*BETAI
                SUM12(II,JJ,KK,L2)=
     +          SUM12(II,JJ,KK,L2)+P*GAMMA
                SUM13(II,JJ,KK,L2)=
     +          SUM13(II,JJ,KK,L2)+P*RHOVRVR
       IF(ZR(I).GT.7777.AND.ZR(I).LT.7778)THEN
c      IF(ZR(I).GT.9.9.AND.ZR(I).LT.10.1)THEN
       WRITE(6,*)'ALPHAI,BETAI,GAMMA,RHOVRVR = ',ALPHAI,BETAI,
     +             GAMMA,RHOVRVR
       WRITE(6,*)'II,JJ,KK,L2,PELEV = ',II,JJ,KK,L2,PELEV(NR)
       WRITE(6,*)'SUM1 = ',SUM1(II,JJ,KK,L2)
       WRITE(6,*)'SUM2 = ',SUM2(II,JJ,KK,L2)
       WRITE(6,*)'SUM3 = ',SUM3(II,JJ,KK,L2)
       WRITE(6,*)'SUM4 = ',SUM4(II,JJ,KK,L2)
       WRITE(6,*)'SUM5 = ',SUM5(II,JJ,KK,L2)
       WRITE(6,*)'SUM6 = ',SUM6(II,JJ,KK,L2)
       WRITE(6,*)'SUM7 = ',SUM7(II,JJ,KK,L2)
       WRITE(6,*)'SUM8 = ',SUM8(II,JJ,KK,L2)
       WRITE(6,*)'SUM9 = ',SUM9(II,JJ,KK,L2)
       WRITE(6,*)'SUM10 = ',SUM10(II,JJ,KK,L2)
       WRITE(6,*)'SUM11 = ',SUM11(II,JJ,KK,L2)
       WRITE(6,*)'SUM12 = ',SUM12(II,JJ,KK,L2)
       WRITE(6,*)'SUM13 = ',SUM13(II,JJ,KK,L2)
c       PAUSE
      ENDIF
                SUMWTSAVE(II,JJ,KK,L2)=SUMWTSAVE(II,JJ,KK,L2)+P
                XWSAVE(II,JJ,KK,L2)=XWSAVE(II,JJ,KK,L2)+P*RX
                YWSAVE(II,JJ,KK,L2)=YWSAVE(II,JJ,KK,L2)+P*RY
                ZWSAVE(II,JJ,KK,L2)=ZWSAVE(II,JJ,KK,L2)+P*RZ
               ENDIF
6298          ENDDO
             ENDDO
            ENDDO
           ENDIF
          ENDIF
c         ENDIF
        ENDDO
       ENDIF
27272  NR=NR+1       
      ENDDO
      GO TO 92923
92929 WRITE(6,*)'JUST FINISHED VR SUMMATION'
c5554  OPEN(103,FILE='/hrd/dat/gustav/tracking/insideabcd')
c      WRITE(103,*)'AT STATEMENT 5554--NF=',NF
c      WRITE(103,*)'JUST FINISHED VR SUMMATION'
c      CLOSE(103)
      DO L=1,2
       DO KK=1,KMAXB
        DO JJ=1,JMAXB
         DO II=1,IMAXB
          ITEST=0
          IF(KK.LE.4)THEN
           KABOT=2
          ELSE
           KABOT=1
          ENDIF
          DO KA=KABOT,2
           DO JA=1,2
            DO IA=1,2
             DIST=DISTXYZ(II,JJ,KK,L,IA,JA,KA)
             IF(DIST.GE.99999999.)THEN
              SUM1(II,JJ,KK,L)=0
              SUM2(II,JJ,KK,L)=0
              SUM3(II,JJ,KK,L)=0
              SUM4(II,JJ,KK,L)=0
              SUM5(II,JJ,KK,L)=0
              SUM6(II,JJ,KK,L)=0
              SUM7(II,JJ,KK,L)=0
              SUM8(II,JJ,KK,L)=0
              SUM9(II,JJ,KK,L)=0
              SUM10(II,JJ,KK,L)=0
              SUM11(II,JJ,KK,L)=0
              SUM12(II,JJ,KK,L)=0
              SUM13(II,JJ,KK,L)=0
              XWSAVE(II,JJ,KK,L)=1000.*SUMWTSAVE(II,JJ,KK,L)
              YWSAVE(II,JJ,KK,L)=1000.*SUMWTSAVE(II,JJ,KK,L)
              ZWSAVE(II,JJ,KK,L)=1000.*SUMWTSAVE(II,JJ,KK,L)
              SUMWTSAVE(II,JJ,KK,L)=0.
              GO TO 10097
             ENDIF
            ENDDO
           ENDDO
          ENDDO
10097    ENDDO
        ENDDO
       ENDDO
      ENDDO
      IOKAY=1
72735 IF(IOKAY.EQ.1)THEN
C
C At end of each complete iteration
C
       WRITE(6,*)'IN ABCD'
       WRITE(6,*)'SUM1,SUM2,SUM3 = ',
     + SUM1(1,1,1,1),SUM2(1,1,1,1),SUM3(1,1,1,1),
     + SUMDBZ(1,1,1,1),SUMWTSAVE(1,1,1,1)
       DO L=1,2
        DO KK=KMIN2,KMAX2
c        OPEN(102,FILE='/hrd/dat/gustav/tracking/abcd')
c        WRITE(102,*)'IN ABCD--K,NF = ',KK,NF
c        CLOSE(102)
         DO JJ=1,JMAXB
          DO II=1,IMAXB
c          write(6,*)'ii,jj,kk,sumwtsave(ii,jj,kk),summer(ii,jj,kk)',
c     +               ii,jj,kk,sumwtsave(ii,jj,kk),summer(ii,jj,kk)
           IF(SUMWTSAVE(II,JJ,KK,L).GT.0.AND.
     +       SUMMER(II,JJ,KK,L).GT.0.)THEN
            SUMMERTEST=SUMMER(II,JJ,KK,L)/SUMWEIGHTP(II,JJ,KK,L)
c            WRITE(6,*)'II,JJ,KK,L,SUMMERTEST = ',
cc     +                 II,JJ,KK,L,SUMMERTEST
c            IF(SUMMERTEST.GT..25.OR.IPLANE.NE.2)THEN
            IF(SUMMERTEST.GT..10)THEN
             SUM1(II,JJ,KK,L)=SUM1(II,JJ,KK,L)/SUMWTSAVE(II,JJ,KK,L)
             SUM2(II,JJ,KK,L)=SUM2(II,JJ,KK,L)/SUMWTSAVE(II,JJ,KK,L)
             SUM3(II,JJ,KK,L)=SUM3(II,JJ,KK,L)/SUMWTSAVE(II,JJ,KK,L)
             SUM4(II,JJ,KK,L)=SUM4(II,JJ,KK,L)/SUMWTSAVE(II,JJ,KK,L)
             SUM5(II,JJ,KK,L)=SUM5(II,JJ,KK,L)/SUMWTSAVE(II,JJ,KK,L)
             SUM6(II,JJ,KK,L)=SUM6(II,JJ,KK,L)/SUMWTSAVE(II,JJ,KK,L)
             SUM7(II,JJ,KK,L)=SUM7(II,JJ,KK,L)/SUMWTSAVE(II,JJ,KK,L)
             SUM8(II,JJ,KK,L)=SUM8(II,JJ,KK,L)/SUMWTSAVE(II,JJ,KK,L)
             SUM9(II,JJ,KK,L)=SUM9(II,JJ,KK,L)/SUMWTSAVE(II,JJ,KK,L)
             SUM10(II,JJ,KK,L)=SUM10(II,JJ,KK,L)/SUMWTSAVE(II,JJ,KK,L)
             SUM11(II,JJ,KK,L)=SUM11(II,JJ,KK,L)/SUMWTSAVE(II,JJ,KK,L)
             SUM12(II,JJ,KK,L)=SUM12(II,JJ,KK,L)/SUMWTSAVE(II,JJ,KK,L)
             SUM13(II,JJ,KK,L)=SUM13(II,JJ,KK,L)/SUMWTSAVE(II,JJ,KK,L)
             XWSAVE(II,JJ,KK,L)=XWSAVE(II,JJ,KK,L)/SUMWTSAVE(II,JJ,KK,L)
             YWSAVE(II,JJ,KK,L)=YWSAVE(II,JJ,KK,L)/SUMWTSAVE(II,JJ,KK,L)
             ZWSAVE(II,JJ,KK,L)=ZWSAVE(II,JJ,KK,L)/SUMWTSAVE(II,JJ,KK,L)
             ZE=SUMDBZ(II,JJ,KK,L)/SUMMER(II,JJ,KK,L)
C            SUMDBZ(II,JJ,KK,L)=10.*ALOG10(ZE)
             SUMDBZ(II,JJ,KK,L)=ZE
            ELSE
             SUM1(II,JJ,KK,L)=0.
             SUM2(II,JJ,KK,L)=0.
             SUM3(II,JJ,KK,L)=0.
             SUM4(II,JJ,KK,L)=0.
             SUM5(II,JJ,KK,L)=0.
             SUM6(II,JJ,KK,L)=0.
             SUM7(II,JJ,KK,L)=0.
             SUM8(II,JJ,KK,L)=0.
             SUM9(II,JJ,KK,L)=0.
             SUM10(II,JJ,KK,L)=0.
             SUM11(II,JJ,KK,L)=0.
             SUM12(II,JJ,KK,L)=0.
             SUM13(II,JJ,KK,L)=0.
             XWSAVE(II,JJ,KK,L)=1000.
             YWSAVE(II,JJ,KK,L)=1000.
             ZWSAVE(II,JJ,KK,L)=1000.
             ZE=SUMDBZ(II,JJ,KK,L)/SUMMER(II,JJ,KK,L)
C            SUMDBZ(II,JJ,KK,L)=10.*ALOG10(ZE)
             SUMDBZ(II,JJ,KK,L)=FLAG
            ENDIF
           ELSEIF(SUMMER(II,JJ,KK,L).GT.0.)THEN
            SUMMERTEST=SUMMER(II,JJ,KK,L)/SUMWEIGHTP(II,JJ,KK,L)
            IF(SUMMERTEST.GT..25.OR.IPLANE.NE.2)THEN
             ZE=SUMDBZ(II,JJ,KK,L)/SUMMER(II,JJ,KK,L)
C            SUMDBZ(II,JJ,KK,L)=10.*ALOG10(ZE)
             SUMDBZ(II,JJ,KK,L)=ZE
            ELSE
             SUMDBZ(II,JJ,KK,L)=FLAG
            ENDIF
            SUM1(II,JJ,KK,L)=0
            SUM2(II,JJ,KK,L)=0
            SUM3(II,JJ,KK,L)=0
            SUM4(II,JJ,KK,L)=0
            SUM5(II,JJ,KK,L)=0
            SUM6(II,JJ,KK,L)=0
            SUM7(II,JJ,KK,L)=0
            SUM8(II,JJ,KK,L)=0
            SUM9(II,JJ,KK,L)=0
            SUM10(II,JJ,KK,L)=0
            SUM11(II,JJ,KK,L)=0
            SUM12(II,JJ,KK,L)=0
            SUM13(II,JJ,KK,L)=0
           ELSE
            SUM1(II,JJ,KK,L)=0
            SUM2(II,JJ,KK,L)=0
            SUM3(II,JJ,KK,L)=0
            SUM4(II,JJ,KK,L)=0
            SUM5(II,JJ,KK,L)=0
            SUM6(II,JJ,KK,L)=0
            SUM7(II,JJ,KK,L)=0
            SUM8(II,JJ,KK,L)=0
            SUM9(II,JJ,KK,L)=0
            SUM10(II,JJ,KK,L)=0
            SUM11(II,JJ,KK,L)=0
            SUM12(II,JJ,KK,L)=0
            SUM13(II,JJ,KK,L)=0
            SUMDBZ(II,JJ,KK,L)=FLAG
           ENDIF
c           IF(KK.EQ.67.AND.II.GE.5.AND.II.LE.80)THEN
c              WRITE(6,*)'FINISH,II,JJ,KK,L,SUMDBZ = ',
c     +         II,JJ,KK,L,SUMDBZ(II,JJ,KK,L)
c           ENDIF
          ENDDO
         ENDDO
        ENDDO      
       WRITE(6,*)'SUM1,SUM2,SUM3,SUMDBZ,SUMWTSAVE = ',
     + SUM1(1,1,1,L),SUM2(1,1,1,L),SUM3(1,1,1,L),
     + SUMDBZ(1,1,1,L),SUMWTSAVE(1,1,1,L)
       ENDDO
      ENDIF
      CLOSE(76)
      RETURN
      END
      SUBROUTINE VRLOCATE(OLAT,OLON,TIMES,
     + RLAT,RLON,ALT,ELEV,AZIM,RANGE,XR,YR,ZR,
     + SMOTIONU,SMOTIONV,ISCANDIM,CENTIME,XSHFT,YSHFT,RAD,THETA,
     + ISCANMAX)
      REAL RANGE(ISCANDIM),XR(ISCANDIM),YR(ISCANDIM),ZR(ISCANDIM)
      REAL RAD(ISCANDIM),THETA(ISCANDIM)
      RALT=ALT/1000.
      PI=ASIN(1.0)*2.
      DTR=PI/180.
      REARTH=6366.
      TDIFF=TIMES-CENTIME
      XSHIFT=TDIFF*SMOTIONU/1000.
      YSHIFT=TDIFF*SMOTIONV/1000.     
      RAZIM=AZIM*DTR
      RELEV=ELEV*DTR
      DO I=1,ISCANMAX
c xradar=horizontal distance from aircraft
c yradar=vertical distance from center of earth
       XRADAR=RANGE(I)*COS(RELEV)
       YRADAR=REARTH+RALT+RANGE(I)*SIN(RELEV)
c radnew=distance of datum from center of earth
       RADNEW=SQRT(XRADAR*XRADAR+YRADAR*YRADAR)
c delangle=angle between vertical at aircraft and vertical at datum
       DELANGLE=ATAN(XRADAR/YRADAR)
c distance along great circle from radar to datum
       DISTANCE=.5*(RADNEW+REARTH+RALT)*DELANGLE
c height=altitude of datum
       HEIGHT=RADNEW-REARTH
c distance2=xradar
       DISTANCE2=RANGE(I)*COS(RELEV)
c height2=altitude of datum not accounting for earth's curvature
       HEIGHT2=RALT+RANGE(I)*SIN(RELEV)
c delx=distance (aircraft/datum) along great circle due to east west
       DELX=DISTANCE*SIN(RAZIM)
c dely=distance(aircraft/datum)along great circle due to north-south
       DELY=DISTANCE*COS(RAZIM)
c dx=east west distance from origin to aircraft
       XLAT=.5*(RLAT+OLAT)*DTR
       DX=(RLON-OLON)*DTR*REARTH*COS(XLAT)
c dy=north south distance from origin to aircraft
       DY=(RLAT-OLAT)*DTR*REARTH
c xshift=east-west distance from lower left corner to origin
c yshift=north-south distance from lower left corner to origin
c XR=distance of datum from lower left corner
c YR=distance of datum from lower left corner
       XR(I)=DELX+DX-XSHIFT+XSHFT
c yshift=distance from lower left corner to origin
       YR(I)=DELY+DY-YSHIFT+YSHFT
       ZR(I)=HEIGHT
       RAD(I)=SQRT(XR(I)*XR(I)+YR(I)*YR(I))
       THETA(I)=ATAN2(YR(I),XR(I))*180./3.14159
       IF(THETA(I).GT.360.)THETA(I)=THETA(I)-360.
       IF(THETA(I).LT.0.)THETA(I)=THETA(I)+360.
c       WRITE(1,*)'I,RANGE,DISTANCE,HEIGHT,DELX,DELY,DX,DY,XSHIFT,'
c     +  'YSHIFT = ',
c     +  I,RANGE(I),DISTANCE,HEIGHT,DELX,DELY,DX,DY,XSHIFT,YSHIFT
      ENDDO
      CONTINUE
      END
