	program fix_fubar_hdrs
C Nor GIV TDR data from 09/07/2012 where master data had
C f***ed-up estended headers while slave extended headers are
C presumably ok. Hope this never happens agian.
C==== ddeclarations ================================
	implicit none 
	integer max_rays, max_gates
	parameter(max_rays = 500, max_gates = 2048)

C IRiS files probalby only hold 5 or less but  I keep it  big just in case...

	integer*4 swapped, read_stuff
	character*80 sweep_fn, temp_fn
C swp_lu is actually a pointer to a file descriptor. On thor
C pointersare 4 byte but on helios, a 64 bit machine, thr pointers are 8 bytes
Cout	integer*4 swp_lu
	integer*8 swp_lu
	integer*4 iostat
	integer*4 nrem, tot_read
	integer*4 num_fields
	integer*4 io_error

	include "iris_f90_structures.h"
	include "TDR_hdr_f90.h"
	include "sigmet_dsp_data_types_f90.h"
					
	type ( struct_hdr ) str_hdr
	type ( product_config ) prod_conf
	type ( product_end ) prod_end
	type ( ingest_configuration) i_config
	type ( task_sched_info ) t_si
	type ( task_dsp_info ) t_dsp
	type ( task_calib_info ) t_calib
	type ( task_range_info ) t_range
	type ( task_scan_info ) t_scan

	type ( ymds_time ) start_time_str
	type ( ymds_time ) end_time_str
	real sweep_start_time
	
	type ( task_misc_info ) t_misc
	type ( task_end_info ) t_end

	type ( task_rhi_scan_info ) t_rhi
	type ( task_ppi_scan_info ) t_ppi
	
	type ( ingest_data_hdr ) idh(MAX_FIELDS) ! /* should be more general! */
	type ( raw_prod_bhdr ) rpbh
	type ( ray_hdr ) rh(max_rays)
	type ( TDR_hdr ) air_hdr(max_rays)
	type ( TDR_hdr ) good_hdr(max_rays,2)
	type ( TDR_hdr ) fix_hdr


C and here are the arrays for the pther data types:
	real*4 dbz(max_gates)
	real*4 dop(max_gates)
	real*4 wid(max_gates)
	real*4 vel_nyq
C  and 3 arrays i can use for displaying sweeps
	real dbz_sweep(max_gates, max_rays)
	real dop_sweep(max_gates, max_rays)
	real spw_sweep(max_gates, max_rays)
	real az_el( 2, max_rays)

C HRD radar tape/file data structures
C Radar tape/file stuff
C 

	character*80 radar_fn
	character*4 time_string

c note thr read_* suntoutines will fill the varaibles intse
C common blocks
	include "hrd_radar_common_blocks.f"

	logical french_antenna
	character*1 antenna_type
C array of flags to select data
	integer data_sel_flags(3)
C
	real fubar_time(max_rays)
	real good_time(max_rays,2)
C
C

c
	integer fubar_lu, good_lu,fix_lu
	character*132 fubar_list, good_list
	character*132 fubar_swp, good_swp(2)
	character*132 swp_fn
	character prefix*15, ext_fn*19
	real time_good, tm_good(2), tm_fubar
C
	integer year,day

	integer jday_start,jday,jday_fubar
 
	integer igood_read
	integer num_fubar_rays, num_good_rays(2)
	integer isweep, ifl, ir, i
	integer num_sweeps, num_bins
	integer ir_want, ifl_want
	real dt_min, del_time
C shit for midnight crossing:
	real day_secs
	logical first_fubar
C === end declarations =========================
C default data types to retrieve
	data_sel_flags(1) = DB_DBZ2
	data_sel_flags(2) = DB_VEL2
	data_sel_flags(3) = DB_WIDTH2
C
	day_secs = 24.0 * 3600.0
C

	igood_read = 1 ! for testing io_error in get tdr ray
	fubar_lu = 10
	good_lu = 11
	fix_lu = 12
C get lists of good and fcked up sweeps
	call getarg(1,fubar_list)
	if(fubar_list .eq. '') then
	  write(6,*)'enter list of fubar sweeps:'
	  read(5,'(a)')fubar_list
	end if
	call getarg(2,good_list)
	if(good_list.eq. '') then
	  write(6,*)'enter list of good  sweeps:'
	  read(5,'(a)')good_list
	end if
	open(fubar_lu,file=fubar_list,form='formatted',status = 'old')
	first_fubar = .true.
	open(good_lu,file=good_list,form='formatted',status = 'old')
C get fugar sweep fn, generate ext hdr fn name
10	read(fubar_lu,'(a)',end = 900)fubar_swp
	call time_from_fn(fubar_swp,year,month,day,ih,im,is,
     +		tm_fubar,jday_fubar)
	if(first_fubar)then
	   jday_start = jday_fubar
cout	   write(66,*)"jday_start: ",jday_start
	   first_fubar = .false.
	end if
	if(jday_fubar .ne. jday_start)then
	  tm_fubar = tm_fubar + (jday_fubar-jday_start)*day_secs
	endif
cout	write(66,*)fubar_swp, tm_fubar, jday_fubar
cout	call flush(66)
c
	call extract_prefix(fubar_swp,prefix)
	ext_fn(1:4) = "aux_"
	ext_fn(5:19) = prefix
cout	write(6,*)' aux file will be: ',ext_fn
	open(fix_lu,file=ext_fn,form='unformatted')
	write(fix_lu)ext_fn

C seardh good list, find bracketin good sweeps
	good_swp(1) = "No preceding file"
	good_swp(2) = "No following file"
	time_good = -1.0 ! prime the pump
	do while (tm_fubar .gt. time_good)
	   read(good_lu,'(a)',end=100)swp_fn
	   call time_from_fn(swp_fn,year,month,day,ih,im,is,
     +		time,jday)
	   if(jday.ne.jday_start) then
		time = time + 
     +		    (jday - jday_start) * day_secs
	   end if
	   time_good = time
	   if(time_good .le. tm_fubar)then
		good_swp(1) = swp_fn
		tm_good(1) = time_good
	   end if
	end do
100	tm_good(2) = time_good
	good_swp(2) = swp_fn
	rewind(good_lu)
cout	write(66,110)fubar_swp(1:20),
cout     +	    good_swp(1)(1:20),good_swp(2)(1:20)
110	format(3(1x,a20))
cout	write(66,*)'Times: ',tm_fubar,tm_good(1),tm_good(2)
dout	call flush(66)
cout	write(6,*)"Pausing"
cout	read(5,*)
C read in headers from fubar and good sweeps:
C read the fubar hdrs, get time for eaxh one
C code to read sweep
C
	read_stuff = 0 ! set to  1 to get massive dump of info
c
	sweep_fn = fubar_swp
C
	call open_iris_file(swp_lu, sweep_fn, iostat)
	call check_byte_swapping(swp_lu, swapped)
	call read_iris_record_1(swp_lu, swapped, read_stuff,
     +		prod_conf, prod_end )
	call read_product_hdr(6, prod_conf, prod_end)
	call read_iris_record_2(swp_lu, swapped, read_stuff, 
     +		 i_config, t_si, 
     +		t_dsp, t_calib, t_range, t_scan,  t_misc, t_end,
     +		t_rhi)
	tot_read = 2 * BLK_LENGTH
	call read_task_hdr(0, t_si, t_dsp, t_calib,
     +		t_range, t_scan, t_misc, t_end, 
     +		t_rhi)
C print task_calib_info.flag bits
Cout	call show_cal_flag_bits(6,t_calib%flags)
C get Nyquist vel from stuff stored in tasd header structures in m/x
C get Nyquist vel from stuff stored in tasd header structures in m/x
cout	wavelength= t_misc%wavelength * 0.0001
cout	call get_nyq_vel(t_dsp%prf_mode, t_dsp%prf,wavelength,vel_nyq )
cout	write(6, *)"Myquist velocity ",vel_nyq," m/s"
dout	if(t_dsp%prf_mode .eq. 0) then
cout	   write(6,*)" Single PRF mode", vel_nyq
cout	else
cout	   write(6,*)" Dual PRF mode ",t_dsp%prf_mode, vel_nyq
cout	end if
C There  may be multiple sweeps per file (although I hpe not ) so
C I need a so loop here.
	num_sweeps = t_scan%num_sweeps
C change 19 June 2012
C file with multiple sweeps will list more than one
C associated file for each variable...
	num_fields = i_config%num_assoc_files/num_sweeps
cout	write(6,*)'mun fields, sweeps ',num_fields, num_sweeps
	do isweep = 1, num_sweeps !  >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

C Now we need to get the ingest darta structures that
C describe each parameter stored in the rays. These are
C sotired in data blocks, so first read the raw product
C block header, then the ingest structures.
	call read_iris_sweep_start(swp_lu, swapped, read_stuff,
     +		rpbh, idh(1), num_fields, nrem, tot_read)
	start_time_str = idh(1)%date
	call read_time_structure(6, iyear, month, iday,
     +		 ih, im, is, is100, start_time_str)
	time = start_time_str%seconds + is100 * 0.01

	sweep_start_time= time
C dump ingest data header variavles
cout	write(6,*)'First ingest data header'
cout	write(6,*)'sweep_num ',idh(1)%sweep_num
cout	write(6,*)'ray_resolution ',
cout     +		idh(1)%ray_resolution
cout	write(6,*)'first_ray_index ',
cout     +		idh(1)%first_ray_index
cout	write(6,*)'expected_num_rays ',
cout     +		idh(1)%expected_num_rays
cout	write(6,*)'num_rays_in_file ',
cout     +		idh(1)%num_rays_in_file

	call flush(6)

C finally read the rays and expand the data, including the extended headers
	  num_fubar_rays = idh(num_fields)%expected_num_rays
	  do i = 1, num_fubar_rays
cout	write( 6, '("ray # ", i3,1x, 58("=") )'), i
	call flush(6)

	   call read_iris_tdr_ray( swp_lu, swapped, read_stuff,
     +		vel_nyq, idh(1), rpbh, rh(i), 
     +		air_hdr(i), dbz, dop, wid, 
     +		data_sel_flags, num_fields, nrem, tot_read,
     +		io_error)
	   if( io_error .ne. igood_read) then
		write(6,*)'crud. read rat error: ', io_error
		go to 333 ! break out
	   end if
D update time:
	  fubar_time(i) = sweep_start_time + 
     +		air_hdr(i)%time_since_sweep_start * 0.001
	  call convert_time(fubar_time(i),ih,im,is)
	  is100 = (time-ih*3600.0-im*60.0-is)*100
C
	   call  read_TDR_hdr(0, air_hdr(i) )
	   num_bins = rh(i)%num_bins_in_ray
C
	if(num_bins.gt.0)then
cout	else
cout	     write(6,1111)i
1111	     format("Ray # ",i3," 0 bins. Empty ray")
	   end if


	  end do ! rays loop

	  if(nrem .gt. 0) then
	     call skip_iris_words(swp_lu, nrem)
	     nrem = 0
	  end if
	end do !  end sweeps loop <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<


333	call close_iris_file(swp_lu)

C ===============================
C read the good sweeps, get tlist of good times to use in search
C code to read sweep
C
	do ifl = 1, 2
	  if(good_swp(ifl)(1:2).eq.'No')go to 555
	  sweep_fn = good_swp(ifl)
c
	call open_iris_file(swp_lu, sweep_fn, iostat)
	call check_byte_swapping(swp_lu, swapped)
	call read_iris_record_1(swp_lu, swapped, read_stuff,
     +		prod_conf, prod_end )
	call read_product_hdr(6, prod_conf, prod_end)
	call read_iris_record_2(swp_lu, swapped, read_stuff, 
     +		 i_config, t_si, 
     +		t_dsp, t_calib, t_range, t_scan,  t_misc, t_end,
     +		t_rhi)
	tot_read = 2 * BLK_LENGTH
	call read_task_hdr(0, t_si, t_dsp, t_calib,
     +		t_range, t_scan, t_misc, t_end, 
     +		t_rhi)
C print task_calib_info.flag bits
Cout	call show_cal_flag_bits(6,t_calib%flags)
C get Nyquist vel from stuff stored in tasd header structures in m/x
C get Nyquist vel from stuff stored in tasd header structures in m/x
cout	wavelength= t_misc%wavelength * 0.0001
cout	call get_nyq_vel(t_dsp%prf_mode, t_dsp%prf,wavelength,vel_nyq )
cout	write(6, *)"Myquist velocity ",vel_nyq," m/s"
dout	if(t_dsp%prf_mode .eq. 0) then
cout	   write(6,*)" Single PRF mode", vel_nyq
cout	else
cout	   write(6,*)" Dual PRF mode ",t_dsp%prf_mode, vel_nyq
cout	end if
C There  may be multiple sweeps per file (although I hpe not ) so
C I need a so loop here.
	num_sweeps = t_scan%num_sweeps
C change 19 June 2012
C file with multiple sweeps will list more than one
C associated file for each variable...
	num_fields = i_config%num_assoc_files/num_sweeps
cout    write(,*)'mun fields, sweeps ',num_fields, num_sweeps
	do isweep = 1, num_sweeps !  >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

C Now we need to get the ingest darta structures that
C describe each parameter stored in the rays. These are
C sotired in data blocks, so first read the raw product
C block header, then the ingest structures.
	call read_iris_sweep_start(swp_lu, swapped, read_stuff,
     +		rpbh, idh(1), num_fields, nrem, tot_read)
	start_time_str = idh(1)%date
	call read_time_structure(6, iyear, month, iday,
     +		 ih, im, is, is100, start_time_str)
	time = start_time_str%seconds + is100 * 0.01

	sweep_start_time= time
C dump ingest data header variavles
cout    write(,*)'First ingest data header'
cout    write(,*)'sweep_num ',idh(1)%sweep_num
cout    write(,*)'ray_resolution ',
cout     +		idh(1)%ray_resolution
cout    write(,*)'first_ray_index ',
cout     +		idh(1)%first_ray_index
cout    write(,*)'expected_num_rays ',
cout     +		idh(1)%expected_num_rays
cout    write(,*)'num_rays_in_file ',
cout     +		idh(1)%num_rays_in_file

	call flush(6)

C finally read the rays and expand the data, including the extended headers

	  num_good_rays(ifl) = idh(num_fields)%expected_num_rays
	  do i = 1, num_good_rays(ifl)
cout	write( 6, '("ray # ", i3,1x, 58("=") )'), i
cout	call flush(6)

	   call read_iris_tdr_ray( swp_lu, swapped, read_stuff,
     +		vel_nyq, idh(1), rpbh, rh(i), 
     +		good_hdr(i,ifl), dbz, dop, wid, 
     +		data_sel_flags, num_fields, nrem, tot_read,
     +		io_error)
	   if( io_error .ne. igood_read) then
		write(6,*)'crud. read rat error: ', io_error
		go to 444 ! break out
	   end if
D update time:
	  good_time(i,ifl) = sweep_start_time + 
     +		good_hdr(i,ifl)%time_since_sweep_start * 0.001
	  call convert_time(good_time(i,ifl),ih,im,is)
	  is100 = (time-ih*3600.0-im*60.0-is)*100
C
	   call  read_TDR_hdr(0, good_hdr(i,ifl) )
	   num_bins = rh(i)%num_bins_in_ray
C
cout	if(num_bins.gt.0)then
cout	else
cout	     write(6,1111)i
cout	   end if
C
	  end do ! rays loop

	  if(nrem .gt. 0) then
	     call skip_iris_words(swp_lu, nrem)
	     nrem = 0
	  end if
	end do !  end sweeps loop <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<


444	call close_iris_file(swp_lu)
555	continue
	end do ! files loop <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
C === end of reading the files
C === code to fics the nearest hdrs ===============
C now find good hdr neatest in tume to fubar hdr
c
	do i = 1, num_fubar_rays
	  dt_min = 36000.0
	  ifl_want = -1
	  ir_want = -1
	  
	  do ifl = 1, 2
	    if(good_swp(ifl)(1:2).ne.'No')then
		do ir = 1, num_good_rays(ifl)
		  del_time=abs(fubar_time(i)-good_time(ir,ifl))
		  if(del_time.lt. dt_min)then
			dt_min = del_time
			ir_want = ir
			ifl_want = ifl
		  end if	
		end do
	     end if
	  end do
	  if(ifl_want .gt. 0) then
		write(fix_lu)dt_min,good_hdr(ir_want,ifl_want)
D debug
d	write(67,6767)i,dt_min,ir_want,ifl_want,
d    +	  fubar_time(i),good_time(ir_want,ifl_want)
6767	format(i3,1x,f5.3,2(1x,i3), 2(1x,f9.2))
	  else
		write(fix_lu)-999.9, air_hdr(i)
	  end if
	end do
C close fubar and ext het file, go get the
C next one.
	close(fix_lu)
	go to 10
C
900	close(fubar_lu)
	end
