	program split_rvp8_files
C read list of p3 rvp8 swp files and split
c into subsets of fore and aft sweeps
	implicit none
	character *132 command
	integer list_lu, fore_lu, aft_lu
	integer split_lu
	character*80  list_fn,fore_fn, aft_fn
Cout	character*80 split_fn
	character*80 swp_fn
	logical fore_tilt, aft_tilt
	integer num_rays, ierror
	real avg_el

		integer num_read,num_fore, num_aft

C 
	list_lu = 10
	fore_lu = 11
	aft_lu = 12
cout	split_lu = 13
cout	split_fn = 'split_script.txt'
cout	open(split_lu,file=split_fn,form='formatted')
	fore_fn = 'fore_sweeps_list.txt'
	aft_fn = 'aft_sweeps_list.txt'
c
	write(6,*)'sweeps list?'
	read(5,'(a)')list_fn
	open(list_lu,file =list_fn,form='formatted',status='old')
	open(fore_lu,file=fore_fn,form='formatted')
	open(aft_lu,file=aft_fn,form='formatted')
C
	num_read = 0
	num_fore = 0
	num_aft = 0
10	read(list_lu,'(a)',end=100,err=100)swp_fn
	num_read = num_read + 1
c check for av tilt
	call check_antenna_tilt(swp_fn,num_rays,avg_el,ierror)
	if(avg_el .gt. 10.0) then
	  fore_tilt = .true.
	  aft_tilt = .false.
	else if(avg_el .lt. -10.0) then
	  fore_tilt = .false.
	  aft_tilt = .true.
	else
	   fore_tilt = .false.
	   aft_tilt = .false.
	end if
	if(fore_tilt) then
	  num_fore = num_fore + 1
	  write(fore_lu,'(a)')swp_fn
	  command = ' '
	  write(command,123) swp_fn(1:23)
123	  format('mv ',a23,' fore_sweeps/')
C debuf
	write(6,*)command
C
	  call system(command)
Cout	  write(split_lu,*)command
	else if(aft_tilt)then
	  num_aft = num_aft + 1
	  write(aft_lu,'(a)')swp_fn
cout	  command = 'mv '// trim(swp_fn) // ' aft_sweeps/'
	  command = ' '
	  write(command,124) swp_fn(1:23)
124	  format('mv ',a23,' aft_sweeps/')
C debug
	  write(6,*)command
	  call system(command)
Cout	  write(split_lu,*)command
	end if
	go to 10
C
100	close(list_lu)
	close(fore_lu)
	close(aft_lu)
	write(6,*)num_read,' files read'
	write(6,*)num_fore,' fore files'
	write(6,*)num_aft, ' aft files'
C
	end
