C Newer version that saves all the rays in a sweep in common 
C blocks...bexause if the screwy way that sigmet
C writes the raw data... p dodge  24 Februaty 2010
C	radar_rvp8_read.f
C This file contains suvroutines that simulate the axtions of
C code in N Groffins radartaperead.f and radardiscread.f. Pupose is to
C inthefrate new radar data fron rvp8 into old hrd code.
C new data ae stored in mant files, while ld data were
C stored in oither one tape or one disc file, so bookeeping
C myst ve a little more conplec.
C p dodge  21 Jan 2010
C

C  stuff in radardiscread1.f
C 
C      subroutine RADARDISCREAD1
C    entry DISCENTRY
C    entry RADARDATA_DISC
C    entry OPENRADARFILE
C      function TIMSEC_DISC
C      subroutine SAVESWEEP_DISC
C      subroutine DISCSEARCH
C      subroutine RADARDISCREWIND
C      subroutine GETSWEEPN_DISC
C      function SPEED1
C      function WDIR1
C      subroutine CHKTM1
C
C ============================================
	subroutine open_rvp8_file(directory, lu, lu_errors, ierr)
C this does not open individula rvp8 files, rather it 
C opens a list of those files, su radar_rvp8_read
C and rvp8_search can fine correct weep to open.
C
C	directory (sharacter): path to sweep files directory
C	lu = logical unit number for file list file
C	lu_errors(it): logical unit for error messages
C	ierr *integera): error status
C		= p meand no errors
C		= -1  means list file is empty
C		>0 open error number fron fortran

	implicit none

	character directory*(*)
	integer*4 lu, lu_errors, ierr
C need HRD common blocks to set sweep counters
	include "hrd_radar_common_blocks.f"
 
C Hide first sweep name here, so you
C so not have to call rvp8_search to prime the pump.
	common /rvp8_files/sweep_open,
     +		current_fptr,
     +		current_fn
	logical sweep_open
C 64 bit machines have 8 byte pointers
	integer*8 current_fptr
	character*132 current_fn
	character command*132
	character skip_string*8
	integer nc
C
	command = " "
C note modified command string to sort
C list...so that master (nrm*.RA@) and slave
C (nrs*.RAW) will be properly interleaved in the
C list
	nc = len(trim(directory)) + 4
	skip_string = ' '
	if(nc .lt. 10) then
	   write(skip_string,"(' -k 1.',i1,1x)")nc
	else
	   write(skip_string,"(' -k 1.',i2,1x)")nc
	end if
	command = 'ls ' // trim(directory)
     +	   //'*RAW* | sort'//skip_string//'  > sweeps_list'
cout	print command
	call system(command)
C get number of lines
C

	open(lu, file = 'sweeps_list',form='formatted',
     +		iostat = ierr)

	read(lu, '(a)')current_fn
	rewind( lu )
	sweep_open = .false.
C
C initialize sweep cointers in hrd common blocks
C set to zero because will be incremented
C in radar_rvp8_read
	nlfsweep = 0
	ntasweep = 0
c
	return
	end
C ================================================================
      subroutine rvp8_search(lu,kindradar,iop,rkey,ierr)
c
c   This subroutine reads the new format data and searches for a 
c specified sweep number or a specified time.  It positions the disc at 
c the begining of the specified sweep number or the specified time.  
c Tapesearch should be used in conjunction with Radardiscread.  It will
c not work by itself.  Tapesearch assumes that a Tape Header has been read.
c Not reading a Tape Header will produce unpredictable results!!!!
c The calling routine sends:
c lu - disc logical unit number               (integer)
c kindradar - kind of radar 1:lf, 2:ta         (integer)
c iop - (1) search by sweep number             (integer)
c       (2) search by time
c rkey - sweep number to search for    (iop=1) (real)
c        time to search for in seconds (iop=2)
c tapesearch returns:
c ierr - error code or size of record in bytes
c         0 no error; good read
c        -2 for end of file, final record on the disc file
C NOTE: I ignore kindradar, as this si not relevant
C I assume that LF sweeops will ve listed in a different
C set of files. Also I ignore iop and only do searches by time.
C Rather than having to open eacg file, I use the time contained
C in the file names to search quickly. I stire the revulting
C file names in a common vlock
C p dodge 26 Jan 2010

	implicit none
	integer lu,kindradar,iop,ierr
	real rkey

	integer i, ibeg, iend,ih,im,is
	real time

	common /rvp8_files/sweep_open,
     +		current_fptr,
     +		current_fn
	logical sweep_open
C pointers are 8 byte on 64 bit machines
	integer*8 current_fptr
	character*132 current_fn
c
	character*132 sweep_fn

C set sweep_open to false so
C first call to radar_rvp8_read will
C open a sweep file
	sweep_open = .false.
	rewind(lu)
	read(lu,'(a)')sweep_fn
c figure out wnere sweep time stats.
C full path coild be something like
C /hrd/dat/giv_radar/nov_30_test/nrm091130220905.RAWJUBV
C and the sweep files name 
C nrm091130220905.RAWJUBV
C or radyrmodahrmnsc.RAWabcd
	i = 1
100	do while(sweep_fn(i:i) .ne. '.')
		i = i + 1
	end do
C parh may contain other "." we need to
C skip over
	if(sweep_fn(i+1:i+3).ne.'RAW')then
	  if(i.lt.132)then
		go to 100
	   else
		ierr = -4
		return
	   end if
	end if
	ibeg = i -  6
	iend = ibeg + 5
	read(sweep_fn(ibeg:iend), '(3i2)')ih,im,is
Cout	write(6,*)'First file: ',sweep_fn
	time = ih*3600.0 + im * 60.0 + is
cout	write(6,'(3i2.2,1x, f8.1)')ih,im,is,time
	current_fn = sweep_fn
C then loop throigh file names intil last file before
C desired time.
	do while( time .lt. rkey)
	   current_fn = sweep_fn
	   read(lu,'(a)', end = 900, err = 910)sweep_fn
	   read(sweep_fn(ibeg:iend), '(3i2)')ih,im,is
cout	   write(6,*)'First file: ',sweep_fn
	   time = ih*3600.0 + im * 60.0 + is
cout	   write(6,'(3i2.2,1x, f8.1)')ih,im,is,time
	end do
	if(time .gt. rkey)then
	   backspace(lu)
	end if
	write(6, *)'current file" ',current_fn
	ierr = 0
C
	return
900	ierr = -2
	current_fn = 'EOF. Time not found in sweeps list'
	return
910	ierr = -1
	current_fn = 'ERROR reading files list'
	return
	end
c ==============================================================
	subroutine radar_rvp8_read(lu,KINDRADAR,IHEADERFLAG,IDATAFLAG,
     +                          IERR)
C This code modifies the program read_iris_sweeps
C to a F90 suvroitne that is called to read one radar ray at a time
c /read in a radar tape file and write out sweeos in the
c SIGMET/Vaisala IRIS Raw data format. to simlate sweeps
C written out by the RVP8. Oh how I did not want to
C write this code.... started 9 Dec 2008. Peter Dodge,
C radar data p;umber, HRD 
C Iris data structures

C
C   This subroutine reads and unpacks the 1988 Radar format data.  
C The data is read from a disc file. The routine
C returns 1 ray of data from one of the radars per call.  Radardiscread
C follows the SIGMET documentation.  It returns the Tape Header information,
C the Data Record Header information, the Ray Header information and the data.
C The Tape Header is a 1024 record, the Data record is variable length with
C a maximum size of 4096 words, the Ray Header which is part of the Data
C record is 22 words long and the data contains a maximum of 512 bins.
C NOTE: rvp8 may contain more than 512 bins !!
C IDRADAR contains the radar being read: 1 for Lower Fuselage and
C 2 for Tail.  LF stands for Lower Fuselage, TA stands for Tail.
C The Tape Header contains information from both radars.
C    The calling program sends:
C    lu - unit number connected to the file
C    KINDRADAR - kind of radar to decode, 0=both, 1=LF, 2=TA (integer)
C    IHEADERFLAG - flag that determines if the user wants the 1024 words
C                  contained in the Tape Header, 0=no, 1=yes.
C                  A subset is returned in the TAPEHEADER common area.(integer)
C    IDATAFLAG - flag that determines the type of data to be returned
C                to the calling program: 
C              bit 2 on: returns dbz
C              bit 1 on: returns velocity    
C              bit 0 on: returns spectral width
C    Radardiscread returns:
C    IERR - error code
C            0 no error; good read
C           -2 end of file(final record on the file)
C    
C    Radardiscread returns two common areas.
C    TAPEHEADER - common area containing some parameters from the data.
C                 Header and a buffer(IHEADER) that contains the 1024 words.
C                 The information in IHEADER is scaled according to the
C                 SIGMET documentation.  The routine returns buffer IHEADER
C                 if IHEADERFLAG equals 1.  IHEADER is set to 0 otherwise.
C                  TAPEHEADER is composed of the followi
C --------- ebd  if original comments -----------
C
	implicit none 
	integer lu,KINDRADAR,IHEADERFLAG,IDATAFLAG
	integer IERR
	include "iris_f90_structures.h"
	include "TDR_hdr_f90.h"
	include "sigmet_dsp_data_types_f90.h"
	include "hrd_radar_common_blocks.f"

	integer max_rays, max_gates
	integer max_fields
	parameter(max_rays = 500, max_gates = max_hrd_dim)
	parameter(MAX_FIELDS = 10) 
C IRiS files probalby only hold 5 or less but  I keep it  big just in case...


	integer*4 swapped, read_stuff
	character*132 sweep_fn
C pointers are 8 byte on 64 bit machines
	integer*8 swp_lu
	integer*4 iostat
	integer*4 nrem, tot_read
					
	type (struct_hdr) str_hdr
	type (product_config) prod_conf
	type (product_end) prod_end
	type (ingest_configuration) i_config
	type (task_sched_info) t_si
	type (task_dsp_info) t_dsp
	type (task_calib_info) t_calib
	type (task_range_info) t_range
	type (task_scan_info) t_scan

	type (ymds_time) start_time_str
	type (ymds_time) end_time_str
	
	type (task_misc_info) t_misc
	type (task_end_info) t_end

	type (task_rhi_scan_info) t_rhi
	type (task_ppi_scan_info) t_ppi
	
	type (ingest_data_hdr) idh(MAX_FIELDS) !)* should be more general! */
	type (raw_prod_bhdr) rpbh
cout.	type (ray_hdr) rh
cout	type (TDR_hdr) air_hdr
	type (ray_hdr) rh(max_rays)
	type (TDR_hdr) air_hdr(max_rays)

C and here are the arrays for the pther data types:
cout	real dbz(max_gates), dop(max_gates), wid(max_gates)
C instead use the arrats contained in the radardata common block

C HRD radar tape/file data structures
C Radar tape/file stuff
C 

c note thr read_* suntoutines will fill the varaibles intse
C common blocks
	logical tail_fore, tail_aft
	logical french_antenna
	character*1 antenna_type
C Here is the common blick that holks
C file pointer, file status, and file neme
	common/rvp8_files/sweep_open,
     *		current_fptr,
     +		current_fn
C
	logical sweep_open
C 64 bit machines use 8 byte pointers
	integer*8 current_fptr
	character*132 current_fn
C Assed this to remember whether ine sweep arrays have been filled
	logical sweep_filled
C and na array with times for eaxh ray. Depinding on whether
C is rotating clockwise or counter
	real ray_time(max_rays)
	integer irot_dir
	integer ray_table(max_rays)
c Here are the arrays
	real dBZ_sweep(max_gates, max_rays)
	real vel_sweep(max_gates, max_rays)
	real wid_sweep(max_gates, max_rays)
C and save in a common block
	common/ stash /ray_table,
Cout     +		rh, air_hdr,
     +		dBZ_sweep, vel_sweep, wid_sweep
C
	real bam16_TO_deg
	real bad_val
	integer iray, isweep, ifirst_ray, last_ray
	integer num_bins, num_good_rays,io_error
	integer num_rays, num_fields, num_sweeps
	integer i, ii, itemp
	real vel_nyq
	real sweep_start, time_start, time_end, azm_m
C save th rh and air_hdr arrays... hp f90 woiln not
C let me put them in common , althoigh it woild when
C they were declared using the record syntac. ke garne...
	save rh, air_hdr
C and save these variables between calls
	save num_rays, num_sweeps,iray, isweep, swapped
	save rpbh, idh, num_fields, nrem, tot_read
	save sweep_start
	save sweep_filled

	bad_val = -999.0

	
	read_stuff = 0 ! set to  1 to get massive dump of info
C set ierr to succesful read initially
	ierr = 0
c Set legacy rvp5 code ised by taycor subroitine
	icode = 0
	icode = ibset(icode,15) ! dBZ
	icode = ibset(icode,14) ! vel
	icode = ibset(icode,13) ! spec edth
	if(kindradar .eq. 1)then
		icode = ibset(icode,11)
	else if(kindradar .eq. 2) then
		icode = ibset(icode,12)
	end if
C
C I had to ass a way to loop back here
C when I read an empty ray (nbins = 0). Previously
C I woild return an ampty ray with ierr= -4, boy other
C HRD code did not check those, and emtyrays had bad times and lat,lons
C so now I will kiip readin intil I get a giid ray) What a tangled web this
C code had become... 29 July 2010
C
100	if( .not.sweep_open) then ! >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
	   sweep_fn = current_fn
	   call open_iris_file(swp_lu, sweep_fn, iostat)
cd	write(6,*)iostat,' iostat opening ', sweep_fn
cd	write(6,*)' returned file pointer ', swp_lu
	if(iostat .ne. 1) then
		stop ' Coild not open file. adios '
	else
cd		write(6,*) "Opened sweep file", sweep_fn
	end if
	   current_fptr = swp_lu
	   sweep_open = .true.

	   call check_byte_swapping(swp_lu, swapped)
c
	call read_iris_record_1(swp_lu, swapped, read_stuff,
     +		prod_conf, prod_end )
cout	write(6,*)' read first record'
C note i donot trust sweep number in raw_psi so i use my own
	itemp = ntasweep
	call read_product_hdr(6, prod_conf, prod_end)

C restore sweeop number
	ntasweep = itemp
	call read_iris_record_2(swp_lu, swapped, read_stuff, 
     +		 i_config, t_si, 
     +		t_dsp, t_calib, t_range, t_scan,  t_misc, t_end,
     +		t_rhi)
cout	write(6,*)' Read record 2'
C load tot_read, whick is updated by subsequent
C calls to read the sweep file
	tot_read = 2 * BLK_LENGTH
C
	call read_task_hdr(6, t_si, t_dsp, t_calib,
     +		t_range, t_scan, t_misc, t_end, 
     +		t_rhi)
C load up bin length in common clock, in km
C rvp5 supportes 3 diff ht laengrhs, so need here
C for legaxy
	if( kindradar .eq. 1 ) then
	  gtlnlf = t_range%output_step * 0.00001
	  rdellf = t_range%first_bin_range * 0.00001
	  rmaxlf = t_range%last_bin_range * 0.00001
	  ivrangelf = 0
	  idradar = 1
	else
	  do ii = 1, 3
	     gtlnta(ii) = t_range%output_step *0.00001
	  end do
	  rdelta = t_range%first_bin_range * 0.00001
	  rmaxta = t_range%last_bin_range * 0.00001
	  ivrangeta = 0
	  idradar = 2
	end if
C get Nyquist vel from stuff stored in tasd header structures in m/x
	vel_nyq = t_misc%wavelength * 0.0001 * t_dsp%prf * 0.25
	write(6, *)"Myquist velocity ",vel_nyq," m/s"
	if( kindradar .eq. 1 ) then
		xniqlf = vel_nyq
	else
		xniqta = vel_nyq
	end if

C There  may be multiple sweeps per file (although I hpe not ) so
C I need a so loop here.
C
	num_sweeps = t_scan%num_sweeps
	num_fields = i_config%num_assoc_files
	write(6,*)'mun fields, sweeps ',num_fields, num_sweeps
C End of iniital file records block
C prime pumps
	isweep = 1
	iray = 1
	sweep_filled = .false.
C save sweep_start time to use in getting ray time
	    sweep_start = time
C
	else
C restore file pointer to current open file
	   swp_lu = current_fptr
	end if ! >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
C Noe if needed, read in a sewwp and firgure out
C which ray is actually the first ray, in tume.
	if( .not.sweep_filled) then
cout	do isweep = 1, num_sweeps !  >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
cout	   write(6,*)" *** Sweep # ",isweep," of file ",current_fn
C Now we need to get the ingest darta structures that
C describe each parameter stored in the rays. These are
C sotired in data blocks, so first read the raw product
C block header, then the ingest structures.
C also increment ntasweep here
Cout	if(iray .eq. 1) then
	   ntasweep = ntasweep + 1
	   call read_iris_sweep_start(swp_lu, swapped, read_stuff,
     +		rpbh, idh(1), num_fields, nrem, tot_read)
	    num_rays = idh(num_fields)%expected_num_rays
Cout	end if

C finally read the rays and expand the data, including the extended headers
C note that if there is an error in this loop, probably 
C an i/o error caused by a truncated fiel. then we
C break lut and reset num_rays to the numver of rays read before the errpr
	  num_good_rays = 0
	  do i = 1, num_rays
cout	   write( 6, '("ray # ", i3, 58("=") )'), i
	   call read_iris_tdr_ray( swp_lu, swapped, read_stuff,
     +		vel_nyq, idh(1), rpbh, rh(i), 
     +		air_hdr(i), dBZ_sweep(1,i), 
     +		vel_sweep(1,i), wid_sweep(1,i), 
     +		num_fields, nrem, tot_read,
     +		io_error)
	    if(io_error .ne. 1) then
		write(6,*)'err in reading ray ',i,io_error
		go to 333
	    else
		num_good_rays = num_good_rays + 1
	    end if

	    if( rh(i)%num_bins_in_ray .gt. 0 ) then
	      call  read_TDR_hdr(0, air_hdr(i) )
	      num_bins = rh(i)%num_bins_in_ray
C update time
	      ray_time(i) = sweep_start + 
     +		air_hdr(i)%time_since_sweep_start * 0.001
	   else
	     ray_time(i) = -1.0
	   end if
cd	write(6,*)'Ray time ',i,ray_time(i)
	 end do
333	 num_rays = num_good_rays
	  sweep_filled = .true.
c find start ray number
	time_start = 1440000.0
	time_end = -time_start
	  do i = 1, num_rays
	     if( ray_time(i) .ge. 0.0) then
		if(ray_time(i).lt.time_start) then
			time_start = ray_time(i)
			ifirst_ray = i
		end if
		if(ray_time(i).gt.time_end) then
			time_end = ray_time(i)
			last_ray = i
		end if
	     end if
	 end do
cd	write(6,*)'First and last ray ',ifirst_ray, last_ray
C now use first and last ray to figure out totation and load
	if( ifirst_ray .gt. last_ray)then
C widdershins (counter-clockwise)
	  iray = 1
	  do i = ifirst_ray, num_rays
		ray_table(iray) = i
		iray = iray + 1
	  end do
	  do i = 1, last_ray
		ray_table(iray) = i
		iray = iray + 1
	  end do
	  do i = last_ray+1, ifirst_ray, 1
		ray_table(iray) = i
		iray = iray + 1
	  end do
	  iray = 1 ! reset to first ray
C 
	else if( ifirst_ray .lt. last_ray)then
C clockwise
	  iray = 1
	  do i = ifirst_ray, 1, -1
		ray_table(iray) = i
		iray = iray + 1
	  end do
	  do i = num_rays, last_ray, -1
		ray_table(iray) = i
		iray = iray + 1
	  end do
	  do i = last_ray-1, ifirst_ray, -1
		ray_table(iray) = i
		iray = iray + 1
	  end do
	  iray = 1 ! reset to first ray
C
	end if
C debug, dump ray_table
cd	do i = 1, num_rays
cd	  write(6,*)'Ray Table ',i,ray_table(i),ray_time(ray_table(i))
cd	end do
C 
	end if
C That ends the block to load up the sweep and ray_table.
C Now use ray table to load up the arrays etc. in the
C HRD common blocks
cd	write(6,*)'Iray, ray rable ',iray,ray_table(iray)
C
c only load extended header if ray had dara, wlse may be garbaage
	if( rh(ray_table(iray))%num_bins_in_ray .gt. 0 ) then
	     call  read_TDR_hdr(0, air_hdr(ray_table(iray)) )
	     num_bins = rh(ray_table(iray))%num_bins_in_ray
c update common block
	      nbins = num_bins
C update time
C  dump weird times for  debugging

cout	   write(6,*)'ext hdr msec: ',
cout     +		air_hdr.time_since_sweep_start,
cout     +		'ray hdr sec ', rh.secs_from_start

	  time = sweep_start + 
     +		air_hdr(ray_table(iray))%time_since_sweep_start * 0.001
	       call convert_time(time, ih, im, is)
	      is100 = (time - ih*3600.0 - im * 60.0 -is) * 100
C note that i swap az and el, so first angle is the rotation, 2nd is the tilt
	     if(kindradar .eq. 1) then ! LF
	        nbinlf = num_bins
C I assume kf like a ppi. may need to change
C az ffom math to nav angles
	        elev = bam16_TO_deg(rh(ray_table(iray))%el_beg )
	        azm = bam16_TO_deg( rh(ray_table(iray))%az_beg )
	     else ! Tail radar
		nbinta = num_bins
C At least on the GIV the tail rotation
C angle is a math angle, with 0 deg starboard, 90 deg
C up , 189 deg port and 270 def down.
C Here i convert to nav angel for HRD software.
	      elev = bam16_TO_deg( rh(ray_table(iray))%az_beg )
	       azm_m = bam16_TO_deg(rh(ray_table(iray))%el_beg )
	      azm = 90.0 - azm_m
	      if(azm .lt. 0.0)azm = azm +360.0
	    end if

	  do i = 1, num_bins
	     dbzbuffer(i) = dBZ_sweep(i, ray_table(iray))
	     velbuffer(i) = vel_sweep(i, ray_table(iray))
	     widthbuffer(i) = wid_sweep(i, ray_table(iray))
	  end do 
	  do i = num_bins + 1, max_gates
	     dbzbuffer(i) = bad_val
	     velbuffer(i) = bad_val
	     widthbuffer(i) = bad_val
	  end do 

	else
C zero length rays will have prev time, 
C azm. elev ... unless first ray in sweep
		if(iray .eq. ray_table(1)) then
		  time = sweep_start
C else leave last time in common block
		end if
		do i = 1, max_gates
			dbzbuffer(i) = bad_val
			velbuffer(i) = bad_val
			widthbuffer(i) = bad_val
		end do 
		nbins = 0
		nbinta = 0
		nbinlf = 0
		ierr = -4
	end if


cout	end do !  end sweeps loop <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

	if( iray .eq. num_rays) then
	   if(isweep .lt. num_sweeps)then
		isweep = isweep + 1
		iray = 1
		sweep_filled = .false.
	   else ! done with this file
		call close_iris_file(swp_lu)
		read(lu,'(a)')current_fn
		sweep_open = .false.
		sweep_filled = .false.
	   end if
	else
		iray = iray + 1
	end if
c if vum_bins is  zero, set ierr so calling prigram can deal with it.
C This will not happen in all sweeps.
C Changed 29 July 2010 to ger another ray id
C this one bad, returning to start of sun.
	if( num_bins .eq. 0) then
Cout		ierr = -4
		go to 100
	end if
	return

	end
C  ===========================================================================
C ise this to check for garbage


 	subroutine get_ray_min_max(arr, num_bins, bad_val,
     +		arr_min, arr_max)
 	integer num_bins
	real bad_val
	real arr(num_bins), arr_min, arr_max

	arr_min = -bad_val
	arr_max = bad_val
	do i = 1, num_bins
	   if( arr(i) .gt. bad_val) then
		if( arr(i) .lt. arr_min) arr_min = arr(i)
		if(arr(i) .gt. arr_max) arr_max = arr(i)
	   end if
	end do
	return
	end
C ===========================================
	subroutine convert_time(time, ih,im,is)
C rreplacement for hrd lib sub ctme, so I can
C run on machines without biglib
	real time
	integer*4 ih, im, is
C
	ih = time / 3600.0
	im = (time - ih * 3600.0) / 60.0
	is = time  - ih * 3600.0 - im * 60.0
C
	return
	end

