C nersion to use on redhat linux systems at hrd,,, nd i hope
C will also compile and run on macs using X11. 
	program plot_radar_check
C Read data dumped by radar check and plot time
C series. Summary file will include suggested correction list
C in SOLO format
	parameter ( max_sweeps = 600 )
	character infile*72, yesno*1, label*30
	real resid_Vg(max_sweeps), resid_Rg(max_sweeps) 
	real tilt_cor(max_sweeps)
C
	real pitch_mean(max_sweeps), pitch_max(max_sweeps),
     +	pitch_min(max_sweeps), drift_mean(max_sweeps),
     +	drift_max(max_sweeps),
     +	drift_min(max_sweeps), roll_mean(max_sweeps),
     +  roll_max(max_sweeps), roll_min(max_sweeps),
     +	   Cc(max_sweeps), D1(max_sweeps), D2(max_sweeps), 
     +	   Ec(max_sweeps), Ac(max_sweeps), B1(max_sweeps), 
     +	   B2(max_sweeps), tilt_mean(max_sweeps), 
     +	   Vh_mean(max_sweeps), 
     +     alt_mean(max_sweeps),
     +	   del_Vh(max_sweeps), del_w(max_sweeps), d_pitch(max_sweeps), 
     +     d_rlaz(max_sweeps),  d_drift(max_sweeps),
     +	   del_h(max_sweeps)
	
C
	integer plotter, plot_type, curve, scatter
	integer isum_lu,iout_lu
	character summary_file*32, flightid*8, st_lbl*6, en_lbl*6
	real mu,mu1,mu2
	character*32 file_create_time, now_time
C
	rad2deg = 180 / acos( -1.0)
	deg2rad = 1.0 / rad2deg
cout	open(1,file='/dev/tty')
	inlu = 10
	isum_lu = 11
	iout_lu = 18

	plotter = 1 
	curve = 1
	scatter = 2
C
	write(6,*)' Enter input file name :'
	read(5,'(a)')infile
	open(unit = inlu, file = infile, form = 'unformatted',
     +		status = 'old')
C	open(unit = lu2, file = 'nadir.dat', form = 'formatted')
C wedge ' Rays searched for sectors within ',wedge,' of 180
	read(inlu)wedge
C	write(iout_lu,*)' Used tail range delay correction: ',rdelcorta
	read(inlu)rdelcorta
	read(inlu)pcor,dcor,rcor, azmcor, elcor
C	write(iout_lu,*)' used Lagrangian mults mu and mu1: ',mu, mu1
	read(inlu)mu, mu1, mu2
C	write(iout_lu,*)' Used expected std dev of w and pitch: ', 
C    +		stdw, stdbeta
	read(inlu)stdC, stdB2, stdw, stdBeta
C	write(iout_lu,*)' sweeps from ',ihs*100+ims,' to ',ihe*100+ime
	read(inlu)stime, etime
C	write(iout_lu,*)' F/ast scan selection mode ',ifast_type
	read(inlu)ifast_type
	if( ifast_type .eq. 1) then
		write(iout_lu,*)' Antenna in FORE scans'
	else if( ifast_type .eq. 2) then
                write(iout_lu,*)' Antenna in AFT scans'
	else
		write(iout_lu,*)' Antenna in Continuous mode'
	end if
C
	read(inlu)flightid, file_create_time
C
	i = 1
	do while ( i .gt. 0)
		read(inlu, end = 500) ntasweep, time, 
     +	 pitch_mean(i), pitch_max(i), pitch_min(i),
     +	 drift_mean(i), drift_max(i), drift_min(i),
     +	 roll_mean(i), roll_max(i), roll_min(i),
     +		   Cc(i), D1(i), D2(i), Ec(i), Ac(i), 
     +		   B1(i), B2(i), nrays, npts
210	format(1x,i3,1x,2(i2.2,1x),i2.2, 2x, 3(1x,f6.2),
     +		7(1x,f7.2), 2(1x, i3) )
		read(inlu, end = 500) tilt_mean(i), 
     +			Vh_mean(i), alt_mean(i),
     +			del_Vh(i), del_w(i), d_pitch(i), 
     +			d_rlaz(i),  d_drift(i),	del_h(i)
211	format(19x,2(f6.2,1x),f5.1,1x,f6.1,5(1x,f7.2), 1x, f7.1 )
		tilt_fix = Ac(i) / ( Vh_mean(i) 
     +			* cosd(drift_mean(i)) * 
     +			cosd(tilt_mean(i)) )
		tilt_cor(i) = tilt_fix * rad2deg
		resid_Vg(i) = Ac(i) + B2(i)
		resid_RG(i) = Cc(i) + D2(i) + Ec(i)
		if( i .eq. 1) then
cout			call ctme(time, ihs, ims, iss)
			ihs = time / 3600.0
			ims = (time - ihs * 3600) / 60.0
			iss = time - ihs * 3600 - ims * 60
		end if
		i = i + 1
	end do
500	write(6,*)' Read ',i,' sweeps.'
cout	call ctme(time, ihe, ime, ise)
	ihe = time / 3600.0
	ime = (time-ihe*3600) / 60.0
	ise = time -ihe*3600 - ime*60

	write(st_lbl,'(3i2.2)')ihs,ims,iss
	write(en_lbl,'(3i2.2)')ihe,ime,ise
	write(6,*)st_lbl, en_lbl
	nsweeps = i-1
C -----
600	write(6,601)
601	format(1x,'Pick variable to plot:',/,
     +	 3x,'1-3: pitch, drift, or roll',/,
     +   3x,'4-7: coefficients C, D1, D2, E',/,
     +	 3x,'8-10: coefficients A, B1, B2',/,
     +   3x,'11-13: Average el, gs or RA',/,
     +   3x,'Dels are error terms: ',/,
     +   3x,'15-16: del VH, del w',/,
     +   3x,'17-19: del pitch, del roll/az, del drift',/,
     +	 3x,'20-21: del ht, tilt cor',/,
     +	 3x,'22-23: residual Vg, Rg',/,
     +   3x,' negative for postscript output also',/,
     +	 3x,'24 - summary list of errors and parameters')
	read(5,*, err=600)iplt_typ
	if( iplt_typ .lt. 0) then
		iplt_typ = -iplt_typ
		ipst_lu = 25
	else
		ipst_lu = 0
	end if
	label = ' '
	if(iplt_typ .ne. 24 )then
620	   write(6,330)curve, scatter
330	 format(' Pick type of plot. Curve (',i1,
     +	   ') or scatter(',i1,'):')
	  read(5,*, err = 620)plot_type
	end if
	if(iplt_typ .eq. 1 )then
		label = 'Pitch'
		call plot_timser3(pitch_mean, pitch_max,pitch_min,
     +		 nsweeps, plotter, label,
     +		plot_type,st_lbl, en_lbl, ipst_lu)
	else if(iplt_typ .eq. 2 )then
		label = 'Drift'
		call plot_timser3(drift_mean, drift_max,drift_min,
     +		 nsweeps, plotter, label,
     +		plot_type,st_lbl, en_lbl, ipst_lu)
	else if(iplt_typ .eq. 3 )then
		label = 'Roll'
		call plot_timser3(roll_mean, roll_max,roll_min, 
     +		  nsweeps, plotter, label,
     +		plot_type,st_lbl, en_lbl, ipst_lu)
	else if(iplt_typ .eq. 4)then
		label = 'C coefficient'
		call plot_timser(Cc, nsweeps, plotter, label,
     +		plot_type,st_lbl, en_lbl, ipst_lu)
	else if(iplt_typ .eq. 5)then
		label = 'D1 coefficient'
		call plot_timser(D1, nsweeps, plotter, label,
     +		plot_type,st_lbl, en_lbl, ipst_lu)
	else if(iplt_typ .eq. 6)then
		label = 'D2 coefficient'
		call plot_timser(D2, nsweeps, plotter, label,
     +		plot_type,st_lbl, en_lbl, ipst_lu)
	else if(iplt_typ .eq. 7)then
		label = 'E coefficient'
		call plot_timser(Ec, nsweeps, plotter, label,
     +		plot_type,st_lbl, en_lbl, ipst_lu)
	else if(iplt_typ .eq. 8)then
		label = 'A coefficient'
		call plot_timser(Ac, nsweeps, plotter, label,
     +		plot_type,st_lbl, en_lbl, ipst_lu)
	else if(iplt_typ .eq. 9)then
		label = 'B1 coefficient'
		call plot_timser(B1, nsweeps, plotter, label,
     +		plot_type,st_lbl, en_lbl, ipst_lu)
	else if(iplt_typ .eq. 10)then
		label = 'B2 coefficient'
		call plot_timser(B2, nsweeps, plotter, label,
     +		plot_type,st_lbl, en_lbl, ipst_lu)
	else if(iplt_typ .eq. 11)then
		label = 'Avg elevation'
		call plot_timser(tilt_mean, nsweeps, plotter, label,
     +		plot_type,st_lbl, en_lbl, ipst_lu)
	else if(iplt_typ .eq. 12)then
		label = 'Avg ground speed'
		call plot_timser(Vh_mean, nsweeps, plotter, label,
     +		plot_type,st_lbl, en_lbl, ipst_lu)
	else if(iplt_typ .eq. 13)then
		label = 'Avg altitude'
		call plot_timser(alt_mean, nsweeps, plotter, label,
     +		plot_type,st_lbl, en_lbl, ipst_lu)
	else if( iplt_typ .eq. 14)then
		write(6,*)' spot 14 is vacant.'
	else if(iplt_typ .eq. 15)then
		label = 'Del ground speed'
		call plot_timser(del_Vh, nsweeps, plotter, label,
     +		plot_type,st_lbl, en_lbl, ipst_lu)
	else if(iplt_typ .eq. 16)then
		label = 'Del w'
		call plot_timser(del_w, nsweeps, plotter, label,
     +		plot_type,st_lbl, en_lbl, ipst_lu)
	else if(iplt_typ .eq. 17)then
		label = 'Del pitch'
		call plot_timser(d_pitch, nsweeps, plotter, label,
     +		plot_type,st_lbl, en_lbl, ipst_lu)
	else if(iplt_typ .eq. 18)then
		label = 'Del roll/az'
		call plot_timser(d_rlaz, nsweeps, plotter, label,
     +		plot_type,st_lbl, en_lbl, ipst_lu)
	else if(iplt_typ .eq. 19)then
		label = 'Del drift'
		call plot_timser(d_drift, nsweeps, plotter, label,
     +		plot_type,st_lbl, en_lbl, ipst_lu)
	else if(iplt_typ .eq. 20)then
		label = 'Del alt'
		call plot_timser(del_h, nsweeps, plotter, label,
     +		plot_type,st_lbl, en_lbl, ipst_lu)
	else if(iplt_typ .eq. 21)then
		label = 'Tilt correction'
		call plot_timser(tilt_cor, nsweeps, plotter, label,
     +		plot_type,st_lbl, en_lbl, ipst_lu)
	else if(iplt_typ .eq. 22)then
		label = 'Residual Vg'
		call plot_timser(resid_Vg, nsweeps, plotter, label,
     +		plot_type,st_lbl, en_lbl, ipst_lu)
	else if(iplt_typ .eq. 23)then
		label = 'Residual Rg'
		call plot_timser(resid_Rg, nsweeps, plotter, label,
     +		plot_type,st_lbl, en_lbl, ipst_lu)
	else if (iplt_typ .eq. 24) then
	   write(6,*)' Enter output file name '
		read(5,'(a)')summary_file
		open(isum_lu, file = summary_file, form = 'formatted')
Cout		call cftime(now_time)
		now_time = 'never'
		write(isum_lu,333)summary_file, now_time
333	format(1x,'This file is ',a32,' created on ',a32)
		write(isum_lu,334)infile, file_create_time 
334	format(1x,'Params from ',a32,' created on ',a32)
		write(isum_lu,'("  Flight ID: ",a8)') flightid
	  	write(isum_lu,'(1x, a6,1x,"to",1x,a6,1x,"UTC")')
     +			st_lbl, en_lbl

		write(isum_lu,*)
     +		  ' Used tail range delay correction: ',rdelcorta
		write(isum_lu,*)' pcor,dcor,rcor, azmcor, elcor:'
		write(isum_lu,*)pcor,dcor,rcor, azmcor, elcor
		write(isum_lu,*)
     +		  ' used Lagrangian mults mu, mu1 and mu2: ',mu, mu1, mu2
		write(isum_lu,*)
     +		  ' Used expected std dev of C, B2, w and pitch: ', 
     +		  stdC, stdB2, stdw, stdBeta
		write(isum_lu,*)' sweeps from ',ihs*100+ims,
     +		  ' to ',ihe*100+ime
		write(isum_lu,*)'    Averages'
		label = 'Pitch Mean'
		call stats_timser(pitch_mean, nsweeps, ar_mean, std_dev,
     +			ar_max, ar_min)
		write(isum_lu,*)label
		write(isum_lu,*)' Mean: ',ar_mean,' Std dev: ',std_dev,
     +			' Max: ', ar_max, ' Min: ',ar_min

		label = 'Drift Mean'
		call stats_timser(drift_mean, nsweeps, ar_mean, std_dev,
     +			ar_max, ar_min)
		write(isum_lu,*)label
		write(isum_lu,*)' Mean: ',ar_mean,' Std dev: ',std_dev,
     +			' Max: ', ar_max, ' Min: ',ar_min

		label = 'Roll Mean'
		call stats_timser(roll_mean, nsweeps, ar_mean, std_dev,
     +			ar_max, ar_min)
		write(isum_lu,*)label
		write(isum_lu,*)' Mean: ',ar_mean,' Std dev: ',std_dev,
     +			' Max: ', ar_max, ' Min: ',ar_min

		label = 'Avg elevation'
		call stats_timser(tilt_mean, nsweeps, ar_mean, std_dev,
     +			ar_max, ar_min)
		write(isum_lu,*)label
		write(isum_lu,*)' Mean: ',ar_mean,' Std dev: ',std_dev,
     +			' Max: ', ar_max, ' Min: ',ar_min

		label = 'Avg ground speed'
		call stats_timser(Vh_mean, nsweeps, ar_mean, std_dev,
     +			ar_max, ar_min)
		write(isum_lu,*)label
		write(isum_lu,*)' Mean: ',ar_mean,' Std dev: ',std_dev,
     +			' Max: ', ar_max, ' Min: ',ar_min

		label = 'Avg altitude'
		call stats_timser(alt_mean, nsweeps, ar_mean, std_dev,
     +			ar_max, ar_min)
		write(isum_lu,*)label
		write(isum_lu,*)' Mean: ',ar_mean,' Std dev: ',std_dev,
     +			' Max: ', ar_max, ' Min: ',ar_min

		write(isum_lu,*)'    Testud et al Parameters'
		label = 'C coefficient'
		call stats_timser(Cc, nsweeps, ar_mean, std_dev,
     +			ar_max, ar_min)
		write(isum_lu,*)label
		write(isum_lu,*)' Mean: ',ar_mean,' Std dev: ',std_dev,
     +			' Max: ', ar_max, ' Min: ',ar_min

		label = 'D1 coefficient'
		call stats_timser(D1, nsweeps, ar_mean, std_dev,
     +			ar_max, ar_min)
		write(isum_lu,*)label
		write(isum_lu,*)' Mean: ',ar_mean,' Std dev: ',std_dev,
     +			' Max: ', ar_max, ' Min: ',ar_min

		label = 'D2 coefficient'
		call stats_timser(D2, nsweeps, ar_mean, std_dev,
     +			ar_max, ar_min)
		write(isum_lu,*)label
		write(isum_lu,*)' Mean: ',ar_mean,' Std dev: ',std_dev,
     +			' Max: ', ar_max, ' Min: ',ar_min

		label = 'E coefficient'
		call stats_timser(Ec, nsweeps, ar_mean, std_dev,
     +			ar_max, ar_min)
		write(isum_lu,*)label
		write(isum_lu,*)' Mean: ',ar_mean,' Std dev: ',std_dev,
     +			' Max: ', ar_max, ' Min: ',ar_min

		label = 'A coefficient'
		call stats_timser(Ac, nsweeps, ar_mean, std_dev,
     +			ar_max, ar_min)
		write(isum_lu,*)label
		write(isum_lu,*)' Mean: ',ar_mean,' Std dev: ',std_dev,
     +			' Max: ', ar_max, ' Min: ',ar_min

		label = 'B1 coefficient'
		call stats_timser(B1, nsweeps, ar_mean, std_dev,
     +			ar_max, ar_min)
		write(isum_lu,*)label
		write(isum_lu,*)' Mean: ',ar_mean,' Std dev: ',std_dev,
     +			' Max: ', ar_max, ' Min: ',ar_min

		label = 'B2 coefficient'
		call stats_timser(B2, nsweeps, ar_mean, std_dev,
     +			ar_max, ar_min)
		write(isum_lu,*)label
		write(isum_lu,*)' Mean: ',ar_mean,' Std dev: ',std_dev,
     +			' Max: ', ar_max, ' Min: ',ar_min

		write(isum_lu, *)'         Errors'
		label = 'Del ground speed'
		call stats_timser(del_Vh, nsweeps, ar_mean, std_dev,
     +			ar_max, ar_min)
		write(isum_lu,*)label
		write(isum_lu,*)' Mean: ',ar_mean,' Std dev: ',std_dev,
     +			' Max: ', ar_max, ' Min: ',ar_min

		label = 'Del w'
		call stats_timser(del_W, nsweeps, ar_mean, std_dev,
     +			ar_max, ar_min)
		write(isum_lu,*)label
		write(isum_lu,*)' Mean: ',ar_mean,' Std dev: ',std_dev,
     +			' Max: ', ar_max, ' Min: ',ar_min

		label = 'Del pitch'
		call stats_timser(d_pitch, nsweeps, ar_mean, std_dev,
     +			ar_max, ar_min)
		write(isum_lu,*)label
		write(isum_lu,*)' Mean: ',ar_mean,' Std dev: ',std_dev,
     +			' Max: ', ar_max, ' Min: ',ar_min

		pcor_new = pcor + ar_mean

		label = 'Del roll/az'
		call stats_timser(d_rlaz, nsweeps, ar_mean, std_dev,
     +			ar_max, ar_min)
		write(isum_lu,*)label
		write(isum_lu,*)' Mean: ',ar_mean,' Std dev: ',std_dev,
     +			' Max: ', ar_max, ' Min: ',ar_min
		rot_angle_cor = rcor - ar_mean
C NOTE: ar_mean is subtracted from rcor and dcor for neww corrections
C because dcor -del_D and rcor = -del_rlaz, because of geometry
C differences.
		label = 'Del drift'
		call stats_timser(d_drift, nsweeps, ar_mean, std_dev,
     +			ar_max, ar_min)
		write(isum_lu,*)label
		write(isum_lu,*)' Mean: ',ar_mean,' Std dev: ',std_dev,
     +			' Max: ', ar_max, ' Min: ',ar_min
		dcor_new = dcor - ar_mean

		label = 'Del alt'
		call stats_timser(del_h, nsweeps, ar_mean, std_dev,
     +			ar_max, ar_min)
		write(isum_lu,*)label
		write(isum_lu,*)' Mean: ',ar_mean,' Std dev: ',std_dev,
     +			' Max: ', ar_max, ' Min: ',ar_min

		label = 'Tilt correction'
		call stats_timser(tilt_cor, nsweeps, ar_mean, std_dev,
     +			ar_max, ar_min)
		write(isum_lu,*)label
		write(isum_lu,*)' Mean: ',ar_mean,' Std dev: ',std_dev,
     +			' Max: ', ar_max, ' Min: ',ar_min
		tilt_cor_new = elcor + ar_mean

		label = 'Residual Vg'
		call stats_timser(resid_Vg, nsweeps, ar_mean, std_dev,
     +			ar_max, ar_min)
		write(isum_lu,*)label
		write(isum_lu,*)' Mean: ',ar_mean,' Std dev: ',std_dev,
     +			' Max: ', ar_max, ' Min: ',ar_min

		label = 'Residual Rg'
		call stats_timser(resid_Rg, nsweeps, ar_mean, std_dev,
     +			ar_max, ar_min)
		write(isum_lu,*)label
		write(isum_lu,*)' Mean: ',ar_mean,' Std dev: ',std_dev,
     +			' Max: ', ar_max, ' Min: ',ar_min
		rdel_new = rdelcorta *1000.0 + ar_mean
C Write suggested corrections
	   write(isum_lu,*)'Suggested corrections file for SOLO:'
	   Write(isum_lu,*)'azimuth_corr           =   0.000'
	   Write(isum_lu,*)'elevation_corr         =   0.000'
	   Write(isum_lu,*)'range_delay_corr       = ',rdel_new
	   Write(isum_lu,*)'longitude_corr         =   0.000'
	   Write(isum_lu,*)'latitude_corr          =   0.000'
	   Write(isum_lu,*)'pressure_alt_corr      =   0.000'
	   Write(isum_lu,*)'radar_alt_corr         =   0.000'
	   Write(isum_lu,*)'ew_gndspd_corr         =   0.000'
	   Write(isum_lu,*)'ns_gndspd_corr         =   0.000'
	   Write(isum_lu,*)'vert_vel_corr          =   0.000'
	   Write(isum_lu,*)'heading_corr           =   0.000'
	   Write(isum_lu,*)'roll_corr              =   0.000'
	   Write(isum_lu,*)'pitch_corr             =   ',pcor_new
	   Write(isum_lu,*)'drift_corr             =   ',dcor_new
	   Write(isum_lu,*)'rot_angle_corr         =   ',rot_angle_cor
	   Write(isum_lu,*)'tilt_corr              =   ',tilt_cor_new

	   close(isum_lu)
	end if
	write(6, *)' paws'
	read(5,*)
	write(6,*)' Another plot? (y or n)'
	read(5,'(a)')yesno
	if( yesno .ne. 'n' ) go to 600
	end
C ---------------------------------------------------------------------------
	subroutine plot_timser(array, nsweeps, plotter, label, 
     +		plot_type, st_lbl, en_lbl, ipst_file)
	integer plotter, nsweeps, plot_type
	real array(nsweeps)
	character  label*30
	character*6 st_lbl, en_lbl
C
	integer curve, scatter
	character cstr*30
	integer*2 string(15)
	logical pen_down
C
	curve = 1
	scatter = 2
	deg2rad = acos(-1.0)/180.0
C Find mean, std dev, max and min
	ar_max = -99999.9
	ar_min = 99999.9
	sum = 0.0
	sum_sq = 0.0
	do i = 1, nsweeps
	  if( array(i) .gt. ar_max) ar_max = array(i)
	  if( array(i) .lt. ar_min) ar_min = array(i)
	  sum = sum + array(i)
	  sum_sq = sum_sq + array(i)**2
	end do
	ar_mean = sum / nsweeps
	sq_av = sum_sq / nsweeps
	diff = sq_av - ar_mean**2
	if( diff .gt. 0.0) then
		std_dev = sqrt( diff )
	else
		std_dev = 0.0
	end if
Cout	if( ar_max .gt. (ar_mean + 2.0 * std_dev) ) then
Cout		ar_max = ar_mean + 2.0 * std_dev
Cout	end if
Cout	if( ar_min .lt. (ar_mean - 2.0 * std_dev) ) then
Cout		ar_min = ar_mean - 2.0 * std_dev
Cout	end if
	dy = (ar_max - ar_min )
	if( abs(dy) .lt. 0.000001) then ! probably zero
		ar_max = ar_max + 0.0001
		dy = (ar_max - ar_min )
	end if
C Initialize plotter
	csiz = 0.1
	tsiz = csiz * 0.5
	xl = 7.0 * csiz
	yb = 7.0 * csiz
	width = 7.0
	depth = 4.0
C initialize plot for X-window
	ires=400
	iwid= (width + 2.0 * xl) * 10 
	iht = (depth + 2.0 * yb) * 10 
	ibkgd_ifgd = 2 ! white on black bkgd
	call initl(plotter,ires,iwid,iht,ibkgd_ifgd,im,im) 
	if( ipst_file .gt. 0) then	! postscript output also
		iwid= (width + 2.0 * xl) * 10 
		iht = (depth + 2.0 * yb) * 10 
		ipst_fnt_size = 10
		call initl(-plotter,ires,iwid,iht,ipst_file,
     +			ipst_fnt_size, im) 
	endif 
	call plot(0.0, 0.0, -3) ! sets origin
C Do axes and labels
	call newpn(1)
	xr = xl + width
	yt = yb + depth
	xc = xl + width * 0.5
	yc = yb + depth * 0.5
	read(label,'(15a2)')(string(i), i = 1, 15)
	call symbl(xl,yt + 3.5 * csiz, csiz, string,0.0,30)
	write(cstr(1:26),'("Mean: ", f7.2," RMS: ",f7.2)')ar_mean, 
     +		std_dev
	read(cstr(1:26),'(13a2)')(string(i), i = 1, 13)
	call symbl(xl + 2.0 * csiz, yt + 2.0 * csiz, csiz, string,
     +		0.0,26)
	write(cstr(1:26),'("Max: ",f7.2," Min: ",f8.2)') ar_max,
     +		ar_min
	read(cstr(1:26),'(13a2)')(string(i), i = 1, 13)
	call symbl(xl + 2.0 * csiz, yt + 0.5 * csiz, csiz, string,
     +		0.0,26)
                                                                       
	write(cstr(1:20),'(a6,1x,"to",1x,a6,1x,"UTC")')st_lbl,
     +		 en_lbl
	read(cstr(1:20),'(10a2)')(string(i), i = 1, 10)
	call symbl(xl + 42.0 * csiz, yt + 0.5 * csiz, csiz, string,
     +		0.0,20)
	cstr(1:8) = 'Sweep # ' 
	read(cstr(1:8),'(4a2)')(string(i), i = 1,4)
	x1 = xl + 0.5* width - 4.0 * csiz
	call symbl(x1,yb - 3.0 * csiz, csiz, string,0.0,8)
C Axes:
	xscale = width / (nsweeps)
	do i = 5, nsweeps, 5
		x1 = xl + i * xscale
		call plot(x1,yb,3)
		call plot(x1, yb + csiz, 2)
		if( mod(i,25).eq.0)then
		  call plot(x1,yb,3)
		  call plot(x1, yb + 1.5 *csiz, 2)
		  cstr = ' '
		  write(cstr(1:3),'(i3)')i
		  read(cstr(1:4),'(2a2)')string(1), string(2)
		  x1 = x1 - 1.5 * csiz
		  call symbl(x1,yb - 1.5 * csiz, csiz, string,0.0,3)
		end if
	end do
C
	dy = (ar_max - ar_min )
	yscale = depth / dy
	dt = abs(dy) * 0.1
	yst = ar_min
	do while( yst .le. ar_max )
		y = yb + (yst-ar_min) * yscale
		call plot(xl, y, 3)
		call plot(xl + csiz, y, 2)
		call plot(xr, y, 3)
		call plot(xr - csiz, y, 2)
		if( abs(yst) .lt. 100.0)then
			write(cstr(1:6),'(f6.2)')yst
		else
			write(cstr(1:6),'(f6.1)')yst
		end if
		read(cstr(1:6),'(3a2)')(string(i), i=1,3)
		call symbl(xl - 6.0 * csiz, y - 0.5 * csiz, 
     +			csiz, string,0.0,6)
		call symbl(xr + 1.0 * csiz, y - 0.5 * csiz, 
     +			csiz, string,0.0,6)
		yst = yst + dt
	end do
C Box
	call plot(xl, yb, 3)
	call plot(xl, yt, 2)
	call plot(xr, yt, 2)
	call plot(xr, yb, 2)
	call plot(xl, yb, 2)
C Zero line
	if( ar_min .lt. 0.0 .and. ar_max .gt. 0.0 ) then
		y = yb - ar_min * yscale
		call plot(xl, y, 3)
		call plot(xr, y, 2)
	end if
C Mean
	call newpn(-5)
	y = yb + (ar_mean - ar_min) * yscale
	call plot(xl, y, 3)
	call plot(xr, y, 2)
C Do plot
	call newpn(-2)
	if( plot_type .eq. curve) then
	  pen_down = .false.
	  do i = 1, nsweeps
	     if(array(i) .ge. ar_min .and. array(i) .le. ar_max) then
		x =  i* xscale + xl
		y =  yb + (array(i) - ar_min) * yscale
		if( pen_down ) then
			call plot(x, y, 2)
		else
			pen_down = .true.
			call plot(x, y, 3)
		end if
	     else
		pen_down = .false.
	     end if
	  end do
	else if( plot_type .eq. scatter) then
	  do i = 1, nsweeps
	     if(array(i) .ge. ar_min .and. array(i) .le. ar_max) then
		x =  i* xscale + xl
		y =  yb + (array(i) - ar_min) * yscale
		call plot(x - tsiz, y, 3)
		call plot(x + tsiz, y, 2)
		call plot(x, y - tsiz, 3)
		call plot(x, y + tsiz, 2)
	     end if
	  end do

	end if
C quit
	call plot(0.0, 0.0, 998)
	return
	end
C -------------------------------------------------------
	subroutine stats_timser(array, nsweeps,  
     +		ar_mean, std_dev, ar_max, ar_min)
	integer nsweeps
	real array(nsweeps)
	deg2rad = acos(-1.0)/180.0
C Find mean, std dev, max and min
	ar_max = -99999.9
	ar_min = 99999.9
	sum = 0.0
	sum_sq = 0.0
	do i = 1, nsweeps
	  if( array(i) .gt. ar_max) ar_max = array(i)
	  if( array(i) .lt. ar_min) ar_min = array(i)
	  sum = sum + array(i)
	  sum_sq = sum_sq + array(i)**2
	end do
	ar_mean = sum / nsweeps
	sq_av = sum_sq / nsweeps
	diff = sq_av - ar_mean**2
	if( diff .gt. 0.0) then
		std_dev = sqrt( diff )
	else
		std_dev = 0.0
	end if
C Should add code to redo, using std dev to reject spikes...
	return
	end
C ---------------------------------------------------------------------------
	subroutine plot_timser3(array, array_max, array_min,
     +		nsweeps, plotter, label, 
     +		plot_type, st_lbl, en_lbl, ipst_file)
	integer plotter, nsweeps, plot_type
C 3 arrays hold means, max's, and min's...
	real array(nsweeps),array_min(nsweeps),array_max(nsweeps)
	character  label*30
	character*6 st_lbl, en_lbl
C
	integer curve, scatter
	character cstr*30
	integer*2 string(15)
	logical pen_down
C
	curve = 1
	scatter = 2
	deg2rad = acos(-1.0)/180.0
C Find mean, std dev, max and min
	ar_max = -99999.9
	ar_min = 99999.9
	sum = 0.0
	sum_sq = 0.0
	do i = 1, nsweeps
	  if( array_max(i) .gt. ar_max) ar_max = array_max(i)
	  if( array_min(i) .lt. ar_min) ar_min = array_min(i)
	  sum = sum + array(i)
	  sum_sq = sum_sq + array(i)**2
	end do
	ar_mean = sum / nsweeps
	sq_av = sum_sq / nsweeps
	diff = sq_av - ar_mean**2
	if( diff .gt. 0.0) then
		std_dev = sqrt( diff )
	else
		std_dev = 0.0
	end if
	dy = (ar_max - ar_min )
	if( abs(dy) .lt. 0.000001) then ! probably zero
		ar_max = ar_max + 0.0001
		ar_min = ar_min - 0.0001
		dy = (ar_max - ar_min )
	end if
C Initialize plotter
	csiz = 0.1
	tsiz = csiz * 0.5
	xl = 7.0 * csiz
	yb = 7.0 * csiz
	width = 7.0
	depth = 4.0
C initialize plot for X-window
	ires=400
	iwid= (width + 2.0 * xl) * 10 
	iht = (depth + 2.0 * yb) * 10 
	call initl(plotter,ires,iwid,iht,im,im,im) 
	if( ipst_file .gt. 0) then	! postscript output also
		iwid= (width + 2.0 * xl) * 10 
		iht = (depth + 2.0 * yb) * 10 
		ipst_fnt_size = 10
		call initl(-plotter,ires,iwid,iht,ipst_file,
     +			ipst_fnt_size, im) 
	endif 
	call plot(0.0, 0.0, -3) ! sets origin
C Do axes and labels
	call newpn(1)
	xr = xl + width
	yt = yb + depth
	xc = xl + width * 0.5
	yc = yb + depth * 0.5
	read(label,'(15a2)')(string(i), i = 1, 15)
	call symbl(xl,yt + 3.5 * csiz, csiz, string,0.0,30)
	write(cstr(1:26),'("Mean: ", f7.2," RMS: ",f7.2)')ar_mean, 
     +		std_dev
	read(cstr(1:26),'(13a2)')(string(i), i = 1, 13)
	call symbl(xl + 2.0 * csiz, yt + 2.0 * csiz, csiz, string,
     +		0.0,26)
	write(cstr(1:26),'("Max: ",f7.2," Min: ",f8.2)') ar_max,
     +		ar_min
	read(cstr(1:26),'(13a2)')(string(i), i = 1, 13)
	call symbl(xl + 2.0 * csiz, yt + 0.5 * csiz, csiz, string,
     +		0.0,26)
                                                                       
	write(cstr(1:20),'(a6,1x,"to",1x,a6,1x,"UTC")')st_lbl,
     +		 en_lbl
	read(cstr(1:20),'(10a2)')(string(i), i = 1, 10)
	call symbl(xl + 42.0 * csiz, yt + 0.5 * csiz, csiz, string,
     +		0.0,20)
	cstr(1:8) = 'Sweep # ' 
	read(cstr(1:8),'(4a2)')(string(i), i = 1,4)
	x1 = xl + 0.5* width - 4.0 * csiz
	call symbl(x1,yb - 3.0 * csiz, csiz, string,0.0,8)
C Axes:
	xscale = width / (nsweeps)
	do i = 5, nsweeps, 5
		x1 = xl + i * xscale
		call plot(x1,yb,3)
		call plot(x1, yb + csiz, 2)
		if( mod(i,25).eq.0)then
		  call plot(x1,yb,3)
		  call plot(x1, yb + 1.5 *csiz, 2)
		  cstr = ' '
		  write(cstr(1:3),'(i3)')i
		  read(cstr(1:4),'(2a2)')string(1), string(2)
		  x1 = x1 - 1.5 * csiz
		  call symbl(x1,yb - 1.5 * csiz, csiz, string,0.0,3)
		end if
	end do
C
	dy = (ar_max - ar_min )
	yscale = depth / dy
	dt = abs(dy) * 0.1
	yst = ar_min
	do while( yst .le. ar_max )
		y = yb + (yst-ar_min) * yscale
		call plot(xl, y, 3)
		call plot(xl + csiz, y, 2)
		call plot(xr, y, 3)
		call plot(xr - csiz, y, 2)
		if( abs(yst) .lt. 100.0)then
			write(cstr(1:6),'(f6.2)')yst
		else
			write(cstr(1:6),'(f6.1)')yst
		end if
		read(cstr(1:6),'(3a2)')(string(i), i=1,3)
		call symbl(xl - 6.0 * csiz, y - 0.5 * csiz, 
     +			csiz, string,0.0,6)
		call symbl(xr + 1.0 * csiz, y - 0.5 * csiz, 
     +			csiz, string,0.0,6)
		yst = yst + dt
	end do
C Box
	call plot(xl, yb, 3)
	call plot(xl, yt, 2)
	call plot(xr, yt, 2)
	call plot(xr, yb, 2)
	call plot(xl, yb, 2)
C Zero line
	if( ar_min .lt. 0.0 .and. ar_max .gt. 0.0 ) then
		y = yb - ar_min * yscale
		call plot(xl, y, 3)
		call plot(xr, y, 2)
	end if
C Mean
	call newpn(-5)
	y = yb + (ar_mean - ar_min) * yscale
	call plot(xl, y, 3)
	call plot(xr, y, 2)
C Do plot
	call newpn(2)
	call newpn(-2)
	if( plot_type .eq. curve) then
	  pen_down = .false.
	  do i = 1, nsweeps
	     if(array(i) .ge. ar_min .and. array(i) .le. ar_max) then
		x =  i* xscale + xl
		y =  yb + (array(i) - ar_min) * yscale
		if( pen_down ) then
			call plot(x, y, 2)
		else
			pen_down = .true.
			call plot(x, y, 3)
		end if
	     else
		pen_down = .false.
	     end if
	  end do
	else if( plot_type .eq. scatter) then
	  do i = 1, nsweeps
	     if(array(i) .ge. ar_min .and. array(i) .le. ar_max) then
		x =  i* xscale + xl
		y =  yb + (array(i) - ar_min) * yscale
		call plot(x - tsiz, y, 3)
		call plot(x + tsiz, y, 2)
		call plot(x, y - tsiz, 3)
		call plot(x, y + tsiz, 2)
	     end if
	  end do
	end if
C plot mins and max's:
	call newpn(-4)
	call newpn(1)
	if( plot_type .eq. curve) then
	  pen_down = .false.
	  do i = 1, nsweeps
	     if(array_max(i) .ge. ar_min .and. 
     +			array_max(i) .le. ar_max) then
		x =  i* xscale + xl
		y =  yb + (array_max(i) - ar_min) * yscale
		if( pen_down ) then
			call plot(x, y, 2)
		else
			pen_down = .true.
			call plot(x, y, 3)
		end if
	     else
		pen_down = .false.
	     end if
	  end do
	  pen_down = .false.
	  do i = 1, nsweeps
	     if(array_min(i) .ge. ar_min .and. 
     +			array_min(i) .le. ar_max) then
		x =  i* xscale + xl
		y =  yb + (array_min(i) - ar_min) * yscale
		if( pen_down ) then
			call plot(x, y, 2)
		else
			pen_down = .true.
			call plot(x, y, 3)
		end if
	     else
		pen_down = .false.
	     end if
	  end do
	else if( plot_type .eq. scatter) then
	  do i = 1, nsweeps
	     if(array_max(i) .ge. ar_min .and. 
     +			array_max(i) .le. ar_max) then
		x =  i* xscale + xl
		y =  yb + (array_max(i) - ar_min) * yscale
		call plot(x - tsiz, y - tsiz, 3)
		call plot(x + tsiz, y + tsiz, 2)
		call plot(x + tsiz, y - tsiz, 3)
		call plot(x - tsiz, y + tsiz, 2)
	     end if
	     if(array_min(i) .ge. ar_min .and. 
     +			array_min(i) .le. ar_max) then
		x =  i* xscale + xl
		y =  yb + (array_min(i) - ar_min) * yscale
		call plot(x - tsiz, y - tsiz, 3)
		call plot(x + tsiz, y + tsiz, 2)
		call plot(x + tsiz, y - tsiz, 3)
		call plot(x - tsiz, y + tsiz, 2)
	     end if
	  end do
	end if
C quit
	call plot(0.0, 0.0, 998)
	return
	end

