	program test_radar_rvp8_read
C
	implicit none
C test my software that reads new IRIS raw files with calls that slodely mimic
C the toutines in radartaperead and radardiscread. My mimicimg
C suvtoutines are contained in radar_rvp8_read.f, which in turn calls
c several Fortran and C toutines that deal with the rvp8 data structures.

	character*36 directory
	integer lu, lu_errors
	integer*4 ierror_flab
C This include file containa the HRD common blocks
	include "hrd_radar_common_blocks.f"
	include "flag_common_block.f"
C
	integer kindradar, iheaderflag, iop
	integer ih_st, im_st, is_st
	integer i, iray, idataflag, ierr
	real time_start, del_time, time_prev
	real rkey
	integer nswp_prev

C
	lu = 10
	lu_errors = 6
	write(6,*)'enter sweep directry'
	read(5,'(a)')directory
	call open_rvp8_file(directory, lu, lu_errors, ierr)

C Call this if you want to change what RVP* header values get
C writtien to the TAPEGEADER and  RAYHEADER common
C blocks.
Crap	call show_hdr_flags( 6 )
Crap	call inter_set_hdr_flags

C search for time
	write(6,*)"enter start time (hhmmss)"
	read(5,'(3i2.2)')ih_st, im_st, is_st
	time_start = 3600.0*ih_st + im_st*60.0 + is_st
	rkey = time_start
	write(6,*)'stating search '
	call flush(6)
	call rvp8_search(lu,kindradar,iop,rkey,ierr)
c

C and read some rays, accum statss
	write(6,*)'now will read some rays'
	call flush(6)
	kindradar = 2 ! tail
C prime pump with one ray
	  call radar_rvp8_read(lu,KINDRADAR,IHEADERFLAG,
     +		IDATAFLAG, IERR)
cout	write(22,*)ierr, nbins
	  call convert_time(time,ih,im,is)
c
	time_prev = time
	iray = 1
	nswp_prev = ntasweep
C check commom clocks
	write(6,*)'Common block stuff:'
	write(6,*)'gtlnta, rmaxta: ', (gtlnta(i), i=1,3), rmaxta
	write(6,*)'rdelta ', rdelta
	call flush(6)

C added stuff to select data types to keep in arrays
C have to read a ray to load availabel dat data thpes
C from the ingest data headers in a sweep file
	  call radar_rvp8_read(lu,KINDRADAR,IHEADERFLAG,IDATAFLAG,
     +                          IERR)
cout	write(22,*)ierr, nbins

Crap	call show_data_flags(6,ierror_flag)
Crap	call set_data_flags(ierror_flag)
C
Crap	pause
CC
	do i = 1, 36000 ! 10 5 minutes of nrm and nrs
	  call radar_rvp8_read(lu,KINDRADAR,IHEADERFLAG,IDATAFLAG,
     +                          IERR)
cout	write(33,*)i,ierr,nbins
	  if( nbins .gt. 0) then
	    call convert_time(time,ih,im,is)
	  end if
c
	  if(ntasweep .gt. nswp_prev)then
		iray = 1
		nswp_prev = ntasweep
	   else
		iray = iray + 1
	    end if
cout	write(6, *)'nbinta, nbins, azm ',nbinta,  nbins, azm
	  write(6,111)i,ih, im, is, is100, azm,elev,rlat,rlon,
     +	    pitch, drift, roll,wd,ws,vws
                                                                       
111	format(i5,1x,3i2.2, '.',i2.2,1x,f6.1,1x,f5.1,2(1x,f7.2),
     +   3(1x,f5.1), 3(1x,f6.1) )
	  del_time = time - time_prev
	  if(abs(del_time) .gt. 1.0) then
	    write(6,112)ntasweep, iray, del_time, azm
                                                                       
112	    format('t jump!: ',i5,1x,i4,' del t: ', f10.3, ' az ',f6.1)
	  end if
	  time_prev = time
	end do
C
	end
